function axeschangelistener(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

ax=double(ev.AffectedObject);

switch src.Name
    case 'XTick'
        oldvalue=get(ax,'xtick');
        newvalue=ev.NewValue;
        if numel(oldvalue)==numel(newvalue) && all(oldvalue==newvalue)
            return
        end
        %else update axes:
        handles=guidata(ax);
        ai=find(handles.allgraphs==ax);
        set([handles.fakeax(ai) handles.fakerax(ai)],'xlim',get(ax,'xlim'),...
            'xtick',newvalue);
        
    case 'YTick'
        oldvalue=get(ax,'ytick');
        newvalue=ev.NewValue;
        if numel(oldvalue)==numel(newvalue) && all(oldvalue==newvalue)
            return
        end
        %else update axes:
        handles=guidata(ax);
        ai=find(handles.allgraphs==ax);
        set([handles.fakeax(ai) handles.fakerax(ai)],...
            'ylim',get(ax,'ylim'),'ytick',newvalue);
        
    case 'ZTick'
        oldvalue=get(ax,'ztick');
        newvalue=ev.NewValue;
        if numel(oldvalue)==numel(newvalue) && all(oldvalue==newvalue)
            return
        end
        %else update axes:
        handles=guidata(ax);
        ai=find(handles.allgraphs==ax);
        set([handles.fakeax(ai) handles.fakerax(ai)],...
            'zlim',get(ax,'zlim'),'ztick',newvalue);

end