function raveinitializesurfaceprofiler(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
        %make surfaceprofiler with x=1st var, y=2nd var, z=3rd var, c=none
        
        inputs.y=[];
        inputs.x=[];
        inputs.dataset=[];
        inputs.xdials=[];
        
        for dd=numel(handles.alldata):-1:1 %for each dataset:
            z=find(handles.isfunction{dd},1);
            if ~isempty(z)
                inputs.z=z;
                inputs.c=z;
                inputs.dataset=dd;
                inputs.funvars=handles.funvars{dd}{z}; %note, these are names, need to convert them to numbers
                
                %remove constants:
                inputs.funvars=setdiff(inputs.funvars,find(handles.isconstant{dd}));
                
                if numel(inputs.funvars)>1
                    inputs.x=inputs.funvars(1);
                    inputs.y=inputs.funvars(2);
                    udata.view.isvalid=1;
                    break
                    
                else
                    inputs.x=[];
                    inputs.y=[];
                    inputs.isvalid=0;
                end
                
            end
        end
        
        if isempty(z)
            inputs.x=[];
            inputs.y=[];
            inputs.z=[];
            inputs.c=[];
            inputs.funvars=[];
            inputs.dataset=1;
            udata.view.isvalid=0;
            
        end
        
        udata.manage.israsterized=0;
        
        %make viewtab info:
        udata.view.analysis=1;
        udata.view.dataset=inputs.dataset;
        udata.view.x=inputs.x;
        udata.view.y=inputs.y;
        udata.view.z=inputs.z;
        udata.view.c=inputs.c;
        udata.view.s=0;
        udata.view.constraints=0;
        
        udata.view.numpts=8;
        udata.view.funvars=inputs.funvars;
        
        udata.view.xdials=inputs.xdials;
        
        udata.view.campos=[];
        udata.view.camtarg=[];
        
        %make format tab info:
        udata.format.bg=1; %index for background color;
        udata.format.grid=2; %index for grid;
        udata.format.mcmap=1; %marker colormap (index?)
        udata.format.edgecolor=[0 0 0]; %color of edges when using solid colors.
        udata.format.facecolor=handles.colors.text;
        udata.format.edgestyle=1; %index of edge style
        udata.format.facestyle=2; %index of face style.
        udata.format.linesize=1;
        udata.format.reversecolors=0;
        udata.format.boxon=1; %show bounding box of axes;
        udata.format.colorbar=0;
        udata.format.cbarhandle=[];
        udata.format.nxlabelrows=0;
        
        %make explre tab info:
        udata.explore.option=1;
        udata.explore.method=cell(0);
        
        %set fakeax userdata (tab info)
        set(handles.fakeax(handles.activeindex),'userdata',udata);
        
        %make the graph
        ravecreatesurfaceprofiler(handles.fig,[]);