function ravearrangeobjectsgreatness(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');


numx=numel(udata.view.x);
numy=numel(udata.view.y);
origin = floor(get(handles.activegraph,'position'));

totalwidth=origin(3);
totalheight=origin(4);

space=handles.prefs.matrixspacing;
space=0;

sizecoefs=[numy numx/2;numy/2 numx];
outdims=sizecoefs\[totalheight-(numx+numy)*(1+space);totalwidth-(numx+numy)*(1+space)]; %subtract 1px per graph for rounding error

height=ceil(outdims(1));
width=ceil(outdims(2));


deezhandles=[handles.subax{handles.activeindex} handles.subfakeax{handles.activeindex} handles.subfakerax{handles.activeindex}] ;

xyhandles=deezhandles(1:numy*numx,:);
xxhandles=deezhandles(numy*numx+1:numy*numx+((numx)^2-numx)/2,:);
yyhandles=deezhandles(numy*numx+1+(numx^2-numx)/2:end,:);

%set up prediction profiler grid of axes.
index=1;
for r=1:1:numy,
    for c=1:1:numx,
        axPos = [round(origin(1))+(c-1)*(width+space) origin(2)+(numy-r)*(height+space) ...
            width height];
        set(xyhandles(index,:),'pos',axPos);
        index=index+1;
    end
end

index=1;
for r=1:1:(numx-1), %first variable
    %for c=(numx-1):-1:r,
    for c=(r+1):1:(numx) %second variable
        axPos = [origin(1)+(width/2)*(r+c-2)  origin(2)+(height+space)*numy + width/2*(c-r-1) width width]; %note, don't actualy need to shrink these, that is handled by view command.
        set(xxhandles(index,:),'pos',axPos);
        index=index+1;
    end
end

index=1;
for r=1:1:(numy-1),
    %for c=(numx-1):-1:r,
    for c=r:1:(numy-1)
        axPos = [origin(1)+(width+space)*numx+height/2*(c-r)   origin(2)+(height+space)*numy-height/2*(r+c+1) ...
            height height]; %note, don't actualy need to shrink these, that is handled by view command.
        set(yyhandles(index,:),'pos',axPos);
        index=index+1;
    end
end