function raveinitializegreatness(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);


%make histogram by default contains the first variable modeled by an RSE in the
%list for y, and all of its x's for x. z,c not used. If no RSEs are present, the create
%function will just show a warning in the axes instead of making the graph.

inputs.y=[];
inputs.x=[];
inputs.dataset=[];

for dd=numel(handles.alldata):-1:1 %for each dataset:
    y=find(handles.isfunction{dd});
    if ~isempty(y)
        inputs.y=y(1:4);
        inputs.z=y(1);
        inputs.dataset=dd;
        inputs.x=handles.funvars{dd}{y(1)};
        inputs.x=inputs.x(~strcmp('constant',handles.datatype{dd}(inputs.x)));
        udata.view.isvalid=1;
        break
    end
end

if isempty(y) || isempty(inputs.x);
    inputs.x=[];
    inputs.y=[];
    inputs.z=[];
    inputs.dataset=1;
    udata.view.isvalid=0;
end

%initialize subplot axes structure:
handles.subax{handles.activeindex}=[];
handles.subfakeax{handles.activeindex}=[];
handles.subfakerax{handles.activeindex}=[];
handles.statsax{handles.activeindex}=[];

udata.manage.israsterized=0;

%make viewtab info:
udata.view.y=inputs.y;
udata.view.x=inputs.x;
udata.view.z=inputs.z;
udata.view.c=inputs.z;
udata.view.s=0;
udata.view.dataset=inputs.dataset;
udata.view.analysis=1;
udata.view.numpts=10; %number of points to sample profiler at
udata.view.numptscontour=40; %number of points used in contour calculation = this^2
udata.view.numcontours=20; %number of contours to draw in contour plots
udata.view.ylabels=[]; %used by profiler
udata.view.constraints=0;

%make format tab info:
udata.format.bg=1; %index for background color;
udata.format.grid=1; %index for grid;
udata.format.marker='.'; % marker string
udata.format.markersize=2; %marker size
udata.format.mcmap=10; %marker colormap (index?)
udata.format.linestyle='-'; %line style string
udata.format.linesize=1; %line thickness;
udata.format.lcmap=1; %line colormap (index?)
udata.format.mcheck=1; %marker check box value
udata.format.lcheck=1; %line check box value
udata.format.linecolor=[0 .5 1]; %main data series color;
udata.format.haircolor=[.8 .8 .8]; %hair line data series color;
udata.format.linecolorString=num2str(udata.format.linecolor);
udata.format.smarthaircolors=1; %make hair lines grey if this variable is constant.
udata.format.reversecolors=0;
udata.format.showpoints=0;
udata.format.pointcolor=[.8 .8 .8];
udata.format.colorbar=0;
udata.format.cbarhandle=0;
udata.format.title='';
udata.format.bold=0;
udata.format.usevariablecolors=1; %for tracers
udata.format.nxlabelrows=0;


%make explre tab info:
udata.explore.option=[];
udata.explore.method=cell(0);

set(handles.fakeax(handles.activeindex),'userdata',udata);

%update guidata
guidata(handles.fig,handles);

%make the graph
ravecreategreatness(handles.fig,[]);
