function formattabpreferencesliders(src,eventdata)
%rave format tab.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
if handles.fronttabsfront==0 %move swap fronttabs and backtabs
    backpos=get(handles.backtabaxes,'position');
    frontpos=get(handles.fronttabaxes,'position');
    set(handles.fronttabaxes,'position',backpos)
    set(handles.backtabaxes,'position',frontpos)
    [x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0);
    set(handles.backtablines,'xdata',x,'ydata',y);       
end
handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1);
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% clear existing tab
delete(handles.tabobjects)

%% do work

appeartext=text(.15-.10317,.97*1.0317-.0317,'Appearance','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);


titletext=uicontrol('position',[origin(1)+25 origin(2)+558 180 20],...
    'style','text','string','Title:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
titlebox=uicontrol('position',[origin(1)+65 origin(2)+560 180 20],...
    'style','edit','string',get(get(handles.activegraph,'title'),'string'),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@title_callback);

varcolorscheck=uicontrol('position',[origin(1)+38+15-30 origin(2)+523 150 20],'style','radiobutton',...
    'string','','value',udata.format.usevariablecolors,'backgroundcolor',handles.colors.tabbg,...
    'callback',@varcheck_callback,'tag','varcolors');
varcolorstext=uicontrol('position',[origin(1)+55+15-30 origin(2)+520 150 20],...
    'style','text','string','Use Dynamic Colors','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');


colortext=uicontrol('position',[origin(1)+40 origin(2)+497 180 20],...
    'style','text','string','Colormap:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');


cdata=ravemakecdata(handles.fig,[],handles.cmapnames{udata.format.mcmap});

markercolor=uicontrol('position',[origin(1)+115 origin(2)+500 120 20],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','cdata',cdata,'callback',@mcolor_callback);

ortext=uicontrol('position',[origin(1)+70 origin(2)+480 150 20],...
    'style','text','string','or','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','normal');

facecheck=uicontrol('position',[origin(1)+38+15-30 origin(2)+463 150 20],'style','radiobutton',...
    'string','','value',~udata.format.usevariablecolors,'backgroundcolor',handles.colors.tabbg,...
    'callback',@facecheck_callback,'tag','facecheck');
facetext=uicontrol('position',[origin(1)+55+15-30 origin(2)+460 150 20],...
    'style','text','string','Face Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

facecolor=uicontrol('position',[origin(1)+145-6+15-30 origin(2)+460 25 25],...
    'style','pushbutton','string','','backgroundcolor',udata.format.facecolor,'value',0,...
    'callback',@faceblob_callback);







%% group items and finish up
handles.tabobjects=[appeartext varcolorstext varcolorscheck facecheck facetext facecolor ortext titletext titlebox colortext markercolor];

handles.activetab='format';

set(handles.infobar,'string','');

guidata(src,handles);


function facecheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
varcolors=findobj(handles.tabobjects,'tag','varcolors');
set(varcolors,'value',0);
udata.format.usevariablecolors=false;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%update:
ravecreatepreferencesliders(handles.fig,[]);


function varcheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
facecheck=findobj(handles.tabobjects,'tag','facecheck');
set(facecheck,'value',0);
udata.format.usevariablecolors=true;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%update:
ravecreatepreferencesliders(handles.fig,[]);


function title_callback(src,ev)
handles=guidata(src);
set(get(handles.activegraph,'title'),'string',get(src,'string'),'fontsize',14);
raveresizeaxes(src,[],handles.activeindex);

function mcolor_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

[newcmap,reverse]=ravechoosecolormap(src,[],udata.format.mcmap,udata.format.reversecolors);

if newcmap==udata.format.mcmap && reverse==udata.format.reversecolors
    return
end

udata.format.mcmap=newcmap;
udata.format.reversecolors=reverse;

colorz=handles.cmapnames;
newcolormap=colorz{newcmap};

cdata=ravemakecdata(handles.fig,[],newcolormap);
set(src,'cdata',cdata);

allcolors=get(handles.fig,'colormap');

if ~udata.format.reversecolors
    deezcolors=allcolors(128*(newcmap-1)+1:128*newcmap,:);
else
    deezcolors=flipud(allcolors(128*(newcmap-1)+1:128*newcmap,:));    
end

udata.format.cmap=deezcolors;
set(handles.fakeax(handles.activeindex),'userdata',udata);


ravecreatepreferencesliders(src,[]);





function faceblob_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.facecolor,'Choose a marker fill color');
set(src,'backgroundcolor',newcolor);
udata.format.facecolor=newcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%update:
ravecreatepreferencesliders(handles.fig,[]);




