function raveinitializeline(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);

d=1; %default data set index

if ~all(handles.isresponse{d}==0)
    x=find((~handles.isconstant{d} & ~handles.isresponse{d}),1);
    y=find((~handles.isconstant{d} & handles.isresponse{d}),1);
    z=0;
    c=0;
else
    x=find((~handles.isconstant{d}),1); %first non-constant value
    y=find((~handles.isconstant{d}),1); %first non-constant value
    z=0;
    c=0;

end



udata.manage.israsterized=0;

%make viewtab info:
udata.view.analysis=1;
udata.view.dataset=1;
udata.view.x=x;
udata.view.y=y;
udata.view.z=z;
udata.view.c=c;
udata.view.s=0;
udata.view.response=0; %response check box value
udata.view.exclude=0; %exclude constant check box value
udata.view.pscale=[];
udata.view.gscale=[];
udata.view.usez=0; %use right axis to display "z" variables
udata.view.usevariablecolors=1;
udata.view.autoscale=1;
udata.view.constraints=0;

%make format tab info:
udata.format.bg=1; %index for background color;
udata.format.grid=2; %index for grid;
udata.format.marker='s'; % marker string
udata.format.markersize=5; %marker size
udata.format.mcmap=1; %marker colormap (index?)
udata.format.linestyle='-'; %line style string
udata.format.linesize=2; %line thickness;
udata.format.lcmap=1; %line colormap (index?)
udata.format.mcheck=1; %marker check box value
udata.format.lcheck=1; %line check box value
udata.format.reversecolors=0;
udata.format.nxlabelrows=0;
udata.format.updatedials=1;


%make explre tab info:
udata.explore.option=[];

%set fakeax userdata (graph/tab info)
set(handles.fakeax(handles.activeindex),'userdata',udata);

%make the graph
ravecreateline(handles.fig,[]);