function boxselectscatter(src,ev) 
handles=guidata(src);
ai=find(handles.allgraphs==src);
udata=get(handles.fakeax(ai),'userdata');
%set(handles.fig,'windowbuttondownfcn',[]);

%check that they clicked on current graph:
% if gco~=handles.activegraph
%     return
% end

clicked=get(src,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

handles.temp.selection=rectangle('position',[xclick yclick eps eps],'linewidth',1,'edgecolor',[1 .5 0],...
    'parent',src,'hittest','off','buttondownfcn','','facecolor','none','clipping','on');
maindata=findobj(src,'tag','main');
%set(maindata,'visible','off');

handles.temp.selected=findobj(src,'tag','selected');
handles.temp.main=findobj(src,'tag','main');
handles.temp.xdata=get(maindata,'xdata');
handles.temp.ydata=get(maindata,'ydata');
handles.temp.cdata=get(maindata,'cdata');
handles.temp.sdata=get(maindata,'sizedata');


handles.temp.xdata=handles.alldata{udata.view.dataset}(:,udata.view.x);
handles.temp.ydata=handles.alldata{udata.view.dataset}(:,udata.view.y);


if udata.view.c~=0
    handles.temp.cdata=handles.alldata{udata.view.dataset}(:,udata.view.c);
else
    if udata.format.ncolor
        handles.temp.cdata=rand(length(handles.temp.xdata),1)-.5; %noisy colors
    else
        handles.temp.cdata=zeros(length(handles.temp.xdata),1); %non-noisy colors cdata=0.5
    end
end

if udata.view.s~=0
    s=handles.alldata{udata.view.dataset}(:,udata.view.s);
    isallonesize=0;
    minsize=udata.format.minmarkersize;
    maxsize=udata.format.maxmarkersize;
    handles.temp.sdata=(((s-min(s))/(max(s)-min(s))).^2)*maxsize + minsize + rand(length(handles.temp.xdata),1)/100;
else
    handles.temp.sdata=ones(length(handles.temp.xdata),1);
    isallonesize=1;
end

set(handles.temp.selected,'visible','off','userdata',false(size(handles.temp.xdata)));

%maintain manual/auto sizing:
handles.temp.axesmode=get(src,'xlimmode');
set(src,'xlimmode','manual','ylimmode','manual');

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@ravesizeselection);
set(handles.fig,'WindowButtonUpFcn',@ravesizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);

guidata(src,handles);

function ravesizeselection(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');

%if in pointselect mode, dont allow sizing, just go straight to buttonupfcn.
maindata=findobj(gca,'tag','main');
if ~isempty(get(maindata,'buttondownfcn'))
    if strcmp(func2str(get(maindata,'buttondownfcn')),'pointselect')
        return
    end
end

finish=get(gca,'currentpoint');
starty=handles.temp.starty;
startx=handles.temp.startx;
endx=finish(1,1,1);
endy=finish(1,2,1);

pos1=min(startx,endx);
pos3=max(startx,endx)-pos1;
pos2=min(starty,endy);
pos4=max(starty,endy)-pos2;

try %#ok<TRYNC>
    set(handles.temp.selection,'position',[pos1 pos2 pos3 pos4]);
end
%determine which points are in this rectangle:

%inpoints=find(inpolygon(handles.temp.xdata,handles.temp.ydata,[pos1 pos1 pos1+pos3 pos1+pos3],[pos2 pos2+pos4 pos2+pos4 pos2]));
inpoints=inpolygon(handles.temp.xdata,handles.temp.ydata,[pos1 pos1 pos1+pos3 pos1+pos3],[pos2 pos2+pos4 pos2+pos4 pos2]);


inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};


if ~any(inpoints)
    set(handles.temp.selected,'visible','off','userdata',false(size(handles.temp.xdata)))
else
    %need to set all data properties so dimensions are correct.
    set(handles.temp.selected,'xdata',handles.temp.xdata(inpoints),'ydata',handles.temp.ydata(inpoints),...
        'cdata',handles.temp.cdata(inpoints),'sizedata',handles.temp.sdata(inpoints),'visible','on','userdata',inpoints);
    if udata.view.s==0 %isallonesize
        set(get(handles.temp.selected,'children'),'markersize',sqrt(udata.format.minmarkersize));
    end
end

function ravesizeselectiondone(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',[]);
set(handles.fig,'WindowButtonUpFcn',[]);
set(gca,'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)
%set(handles.temp.main,'visible','on');

delete(handles.temp.selection);

%store indices of selected points.
inpoints=get(handles.temp.selected,'userdata');

handles.isselected{udata.view.dataset}{udata.view.analysis}=get(handles.temp.selected,'userdata');
set(handles.fakeax(ai),'userdata',udata);
guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected',1);

