function lassoselectscatter(src,ev) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);

ai=find(handles.allgraphs==src);

udata=get(handles.fakeax(ai),'userdata');
%set(handles.fig,'windowbuttondownfcn',[]);

%check that they clicked on current graph:

clicked=get(src,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.xpoints=xclick;
handles.temp.ypoints=yclick;
%fill color:
% handles.temp.selection=fill(xclick, yclick,get(handles.fakerax(handles.activeindex),'color'),'linewidth',1,'edgecolor',[1 .5 0],...
%     'parent',handles.activegraph,'hittest','off','buttondownfcn','','clipping','on');
handles.temp.selection=patch(xclick, yclick,get(handles.fakerax(ai),'color'),'linewidth',1,'edgecolor',[1 .5 0],...
    'parent',src,'hittest','off','buttondownfcn','','clipping','on');

uistack(handles.temp.selection,'bottom');
maindata=findobj(src,'tag','main');
%set(maindata,'visible','off');

handles.temp.selected=findobj(src,'tag','selected');
handles.temp.main=findobj(src,'tag','main');
handles.temp.xdata=get(maindata,'xdata');
handles.temp.ydata=get(maindata,'ydata');
handles.temp.cdata=get(maindata,'cdata');
handles.temp.sdata=get(maindata,'sizedata');

handles.temp.xdata=handles.alldata{udata.view.dataset}(:,udata.view.x);
handles.temp.ydata=handles.alldata{udata.view.dataset}(:,udata.view.y);


if udata.view.c~=0
    handles.temp.cdata=handles.alldata{udata.view.dataset}(:,udata.view.c);
else
    if udata.format.ncolor
        handles.temp.cdata=rand(length(handles.temp.xdata),1)-.5; %noisy colors
    else
        handles.temp.cdata=zeros(length(handles.temp.xdata),1); %non-noisy colors cdata=0.5
    end
end

if udata.view.s~=0
    s=handles.alldata{udata.view.dataset}(:,udata.view.s);
    isallonesize=0;
    minsize=udata.format.minmarkersize;
    maxsize=udata.format.maxmarkersize;
    handles.temp.sdata=(((s-min(s))/(max(s)-min(s))).^2)*maxsize + minsize + rand(length(handles.temp.xdata),1)/100;
else
    handles.temp.sdata=ones(length(handles.temp.xdata),1);
    isallonesize=1;
end

set(handles.temp.selected,'visible','off','userdata',false(size(handles.temp.xdata)));



%maintain manual/auto sizing:
handles.temp.axesmode=get(src,'xlimmode');
set(src,'xlimmode','manual','ylimmode','manual');

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@sizelasso);
set(handles.fig,'WindowButtonUpFcn',@sizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);

guidata(src,handles);

function sizelasso(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');

mousenew = get(handles.allgraphs(ai),'CurrentPoint');
mousenew = mousenew(1,1:2);

% append the new point on the end of the last lasso
handles.temp.xpoints = [get(handles.temp.selection,'xdata');mousenew(1,1)];
handles.temp.ypoints = [get(handles.temp.selection,'ydata');mousenew(1,2)];

% replot the newly extended lasso
set(handles.temp.selection,'xdata',handles.temp.xpoints,'ydata',handles.temp.ypoints)

%determine which points are in this region:
%inpoints=find(inpolygon(handles.temp.xdata,handles.temp.ydata,handles.temp.xpoints,handles.temp.ypoints));
inpoints=inpolygon(handles.temp.xdata,handles.temp.ydata,handles.temp.xpoints,handles.temp.ypoints);
inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};

nothidden=handles.isvisible{udata.view.dataset}{udata.view.analysis};


if ~any(inpoints)
    set(handles.temp.selected,'visible','off','userdata',false(size(handles.temp.xdata)))
else
    %need to set all data properties so dimensions are correct.
    set(handles.temp.selected,'xdata',handles.temp.xdata(inpoints),'ydata',handles.temp.ydata(inpoints),...
        'cdata',handles.temp.cdata(inpoints),'sizedata',handles.temp.sdata(inpoints),'visible','on','userdata',inpoints);
    if udata.view.s==0 %isallonesize
        set(get(handles.temp.selected,'children'),'markersize',sqrt(udata.format.minmarkersize));
    end

end



function sizeselectiondone(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',[]);
set(handles.fig,'WindowButtonUpFcn',[]);
set(gca,'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)
%set(handles.temp.main,'visible','on');

delete(handles.temp.selection);

%store indices of selected points.
inpoints=get(handles.temp.selected,'userdata');

handles.isselected{udata.view.dataset}{udata.view.analysis}=get(handles.temp.selected,'userdata');
set(handles.fakeax(ai),'userdata',udata);
guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected',1);
