function raveinitializescatter3D(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
%make scatter graph with x=1st var, y=2nd var, z=3rd var, c=none
        
        d=1; %default data set index
        
        vars=find(~handles.isconstant{d},3);
        x=vars(1);
        y=vars(2);
        z=vars(3);
        c=0;
        s=0;
        
        udata.manage.israsterized=0;
        
        %make viewtab info:
        udata.view.analysis=1;
        udata.view.dataset=1;
        udata.view.x=x;
        udata.view.y=y;
        udata.view.z=z;
        udata.view.c=c;
        udata.view.s=s;
        udata.view.response=0; %response check box value
        udata.view.exclude=0; %exclude constant check box value
        udata.view.campos=[];
        udata.view.camtarg=[];
        udata.view.hiderotate=0;
        udata.view.constraints=0;
        
        %make format tab info:
        udata.format.bg=1; %index for background color;
        udata.format.grid=2; %index for grid;
        udata.format.marker='o'; % marker string
        udata.format.minmarkersize=25; %min marker size (pixels^2)
        udata.format.maxmarkersize=625; %max marker size (pixels^2)
        udata.format.markerfill=2; %marker fill style index.
        udata.format.mcmap=1; %marker colormap (index?)
        udata.format.mcheck=1; %marker check box value
        udata.format.ncolor=0; %noisy colors check box value;
        udata.format.boxon=1; %show bounding box of axes;
        udata.format.colorbar=0;
        udata.format.cbarhandle=[];
        udata.format.reversecolors=0;
        udata.format.nxlabelrows=0;
        
        %make explre tab info:
        udata.explore.option=1;
        udata.explore.method=cell(0);
        
        %set fakeax userdata (tab info)
        set(handles.fakeax(handles.activeindex),'userdata',udata);
        
        %make the graph
        ravecreatescatter3D(handles.fig,[]);
        