function raveinitializehistogram(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);

%make histogram by default contain the first variable in the
%list. for histogram only x is used, not y,z,c...
x=find(~handles.isconstant{1},1);

%initialize subplot axes structure:
handles.subax{handles.activeindex}=[];
handles.subfakeax{handles.activeindex}=[];
handles.subfakerax{handles.activeindex}=[];
handles.statsax{handles.activeindex}=[];

udata.manage.israsterized=0;

%make viewtab info:
udata.view.analysis=1;
udata.view.dataset=1;
udata.view.x=x;
udata.view.y=0;
udata.view.z=0;
udata.view.s=0;
udata.view.c=0;
udata.view.response=0; %response check box value
udata.view.exclude=1; %exclude constant check box value
udata.view.outliers=0; %remove outliers check box value
udata.view.stddevs=3; %number of std deviations that define outliers
udata.view.nbars=20; %number of bars to draw.
udata.view.barwidth=1; %relative width of bars.
udata.view.showstats=1; %show distribution statistics
udata.view.normalize=0; %show probabilities instead of counts;
udata.view.stack=0; %stack vertically instead of horizontally;
udata.view.constraints=0;


%make format tab info:
udata.format.bg=1; %index for background color;
udata.format.grid=1; %index for grid;
udata.format.facecolor=[.3 .6 1]; %bar face color
udata.format.edgecolor=[0 0 0];
udata.format.drawedge=1;
udata.format.orient='vertical'; %bar orientation
udata.format.nxlabelrows=0;

%make explre tab info:
udata.explore.option=[];
udata.explore.method=cell(0);

set(handles.fakeax(handles.activeindex),'userdata',udata);

%update guidata
guidata(handles.fig,handles);

%make the graph
ravecreatehistogram(handles.fig,[]);