function viewtabcdf(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);

%move front tabs to front if necessary
if handles.fronttabsfront==0 %move swap fronttabs and backtabs
    backpos=get(handles.backtabaxes,'position');
    frontpos=get(handles.fronttabaxes,'position');
    set(handles.fronttabaxes,'position',backpos)
    set(handles.backtabaxes,'position',frontpos)
    [x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
    set(handles.backtablines,'xdata',x,'ydata',y);   
    set(handles.fronttabaxes,'xcolor',handles.colors.tabbg,'ycolor',handles.colors.tabbg);
    set(handles.backtabaxes,'xcolor',handles.colors.frame,'ycolor',handles.colors.frame);
end
handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');

%% clear existing tab
%delete(handles.tabobjects)

%% get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
view=udata.view; %get view tab structure.


%% text headers

projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

dataseriestext=text(.15-.10317,.75*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

optionstext=text(.15-.10317,.20*1.0317-.0317,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

%% text labels

analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');

datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

xaxistext=text(.25-.10317,.72*1.0317-.0317,'Choose Variables:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

yaxistext=text(.25-.10317,.37*1.0317-.0317,'Y-Axis:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

%% variable lists

analysismenu=uicontrol('position',[origin(1)+55 origin(2)+535 180 30],...
    'style','popupmenu','string',handles.analysisnames,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','callback',@analysismenu_callback,'value',udata.view.analysis);

datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+490 180 30],...
    'style','popupmenu','string',handles.datasetnames,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','callback',@datasetmenu_callback,'value',udata.view.dataset);

xaxismenu=uicontrol('position',[origin(1)+55 origin(2)+235 180 200],...
    'style','listbox','string',handles.allnames{1},'value',[1 2],...
    'backgroundcolor',[1 1 1],'tag','xaxismenu','max',50,'callback',@xaxismenu_callback);

%% buttons

scalebutton=uicontrol('position',[origin(1)+55 origin(2)+065 180 30],...
    'style','pushbutton','string','Scale/Transform Variables','backgroundcolor',handles.colors.buttonbg);

useresponsedata=uicontrol('position',[origin(1)+55 origin(2)+035 200 30],...
    'style','checkbox','string','Limit Menu to Response Variables','backgroundcolor',handles.colors.tabbg,...
    'tag','useresponsedata','callback',@useresponsedata_callback);
excludecheck=uicontrol('position',[origin(1)+55 origin(2)+010 200 30],...
    'style','checkbox','string','Hide constant columns in menus',...
    'backgroundcolor',handles.colors.tabbg,'value',view.exclude,'callback',@excludecheck_callback,'tag','excludecheck');

countbutton=uicontrol('position',[origin(1)+92 origin(2)+204 100 30],...
    'style','radiobutton','string','count',...
    'backgroundcolor',handles.colors.tabbg,'value',view.exclude,'callback',@countbutton_callback,'tag','countbutton');
probbutton=uicontrol('position',[origin(1)+152 origin(2)+204 100 30],...
    'style','radiobutton','string','frequency',...
    'backgroundcolor',handles.colors.tabbg,'value',view.exclude,'callback',@probbutton_callback,'tag','probbutton',...
    'value',0);

outlierscheck=uicontrol('position',[origin(1)+55 origin(2)+170 200 30],...
    'style','checkbox','string','Exclude outliers beyond       sigma',...
    'backgroundcolor',handles.colors.tabbg,'value',view.outliers,'callback',@outlierscheck_callback,'tag','outlierscheck');
outliersvalue=uicontrol('position',[origin(1)+191 origin(2)+176 16 20],...
    'style','edit','string','3',...
    'backgroundcolor',handles.colors.tabbg,'value',view.stddevs,'callback',@outliersvalue_callback,'tag','outliersvalue');

statscheck = uicontrol('position',[origin(1)+55 origin(2)+140 200 30],...
    'style','checkbox','string','Show distribution statistics',...
    'backgroundcolor',handles.colors.tabbg,'value',view.showstats,'callback',@statscheck_callback,'tag','statscheck');



%% group items and finish up
handles.tabobjects=[datasettext xaxistext datasetmenu xaxismenu,...
    scalebutton analysistext projecttext analysismenu dataseriestext optionstext excludecheck useresponsedata yaxistext,...
    countbutton probbutton outlierscheck outliersvalue statscheck];

handles.activetab='view';

guidata(src,handles);

% update menus to hide excluded vars
viewtabmenufilter(src,[])


%% Exclude hidden variables from menus:

function viewtabmenufilter(src,eventdata) %#ok<INUSD>

handles=guidata(src);

%get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
view=udata.view; %get view tab structure.

datasetmenu=findobj(handles.tabobjects,'tag','datasetmenu');
xaxismenu=findobj(handles.tabobjects,'tag','xaxismenu');

%get old strings/values
oldxvalue=view.x;

d=get(datasetmenu,'value');

%if get(useresponsedata,'value') && get(excludecheck,'value') && ~all(handles.isresponse{d}==0)
if view.response && view.exclude && ~all(handles.isresponse{d}==0)
    %filter menus by responses and hide constant cols

    %get new strings/values
    newxstring=handles.allnames{d}(~handles.isconstant{d} & ~handles.isresponse{d}); %list of variable names with the constant ones removed.
    newxvalue=zeros(1,length(oldxvalue));
    for jj=1:length(oldxvalue)
        newxvalue(jj)=find(strcmp(handles.allnames{d}(oldxvalue(jj)),newxstring));
    end
    
    if isempty(newxvalue)
        newxvalue=1;
    end

    %store column numbers of available cols. pulldown menus index into these:
    handles.visiblexcols=find((~handles.isconstant{d} & ~handles.isresponse{d}));

    %reset menu strings/values to match displayed data.
    set(xaxismenu,'string',newxstring,'value',newxvalue);

elseif view.response && ~all(handles.isresponse{d}==0)    
    %filter responses only

    %get new strings/values
    newxstring=handles.allnames{d}(~handles.isresponse{d}); %list of variable names with the constant ones removed.
    newxvalue=zeros(1,length(oldxvalue));
    for jj=1:length(oldxvalue)
        newxvalue(jj)=find(strcmp(handles.allnames{d}(oldxvalue(jj)),newxstring));
    end
    
    if isempty(newxvalue)
        newxvalue=1;
    end
  
    %store column numbers of available cols. pulldown menus index into these:
    handles.visiblexcols=find((~handles.isresponse{d}));
   
    %reset menu strings/values to match displayed data.
    set(xaxismenu,'string',newxstring,'value',newxvalue);

elseif view.exclude %hide constant cols only

    %get new strings/values
    newxstring=handles.allnames{d}(~handles.isconstant{d}); %list of variable names with the constant ones removed.
    newxvalue=zeros(1,length(oldxvalue));
    for jj=1:length(oldxvalue)
        newxvalue(jj)=find(strcmp(handles.allnames{d}(oldxvalue(jj)),newxstring));
    end
    
    if isempty(newxvalue)
        newxvalue=1;
    end
      
    %store column numbers of available cols. pulldown menus index into these:
    handles.visiblexcols=find((~handles.isconstant{d}));
    
    %reset menu strings/values to match displayed data.
    set(xaxismenu,'string',newxstring,'value',newxvalue);

else %show all variables

    %get new strings/values
    newxstring=handles.allnames{d}; %list of variable names with the constant ones removed.
    newxvalue=zeros(1,length(oldxvalue));
    for jj=1:length(oldxvalue)
        newxvalue(jj)=find(strcmp(handles.allnames{d}(oldxvalue(jj)),newxstring));
    end
    
    if isempty(newxvalue)
        newxvalue=1;
    end

    %store column numbers of available cols. pulldown menus index into these:
    handles.visiblexcols=1:1:length(handles.allnames{d});

    %reset menu strings/values to match displayed data.
    set(xaxismenu,'string',newxstring,'value',newxvalue);


end

guidata(src,handles)

%% Here be callbacks:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function datasetmenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
%update other menus to show correct variables

xaxismenu=findobj(handles.tabobjects,'tag','xaxismenu');
% analysismenu=findobj(handles.tabobjects,'tag','analysismenu');
datasetmenu=findobj(handles.tabobjects,'tag','datasetmenu');
% useresponsedata=findobj(handles.tabobjects,'tag','useresponsedata');
% excludecheck=findobj(handles.tabobjects,'tag','excludecheck');

d=get(datasetmenu,'value');

if ~all(handles.isresponse{d}==0)
    x=find((~handles.isconstant{d} & ~handles.isresponse{d}),1);
else
    x=find((~handles.isconstant{d}),1);
end


%set fakeax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.dataset=get(datasetmenu,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
handles.graphdataset(handles.activeindex)=get(src,'value');
guidata(src,handles);

viewtabmenufilter(src,[])

set(xaxismenu,'value',x)

ravecreatecdf(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function analysismenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
handles.graphanalysis(handles.activeindex)=get(src,'value');
guidata(src,handles);

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatecdf(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xaxismenu_callback(src,eventdata) %#ok<INUSD,INUSD>
handles=guidata(src);

xaxismenu=findobj(handles.tabobjects,'tag','xaxismenu');
analysismenu=findobj(handles.tabobjects,'tag','analysismenu');
datasetmenu=findobj(handles.tabobjects,'tag','datasetmenu');
useresponsedata=findobj(handles.tabobjects,'tag','useresponsedata');
excludecheck=findobj(handles.tabobjects,'tag','excludecheck');

xaxismenustring=get(xaxismenu,'string');

constcols=setdiff(1:length(xaxismenustring),get(xaxismenu,'value'));
newcstring=[xaxismenustring(constcols);cellstr('')];

handles.visibleccols=[find(ismember(handles.allnames{get(datasetmenu,'value')},newcstring)) length(handles.allnames{get(datasetmenu,'value')})+1];


%if selected isconstant, turn off filter constant button
if any(handles.isconstant{get(datasetmenu,'value')}(handles.visiblexcols(get(xaxismenu,'value'))))
    set(excludecheck,'enable','off')  
else
    set(excludecheck,'enable','on')    
end

guidata(src,handles);

%set fakeax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.analysis=get(analysismenu,'value');
udata.view.dataset=get(datasetmenu,'value');
udata.view.x=handles.visiblexcols(get(xaxismenu,'value'));
udata.view.response=get(useresponsedata,'value'); %response check box value
udata.view.exclude=get(excludecheck,'value'); %exclude constant check box value

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatecdf(src,[]);


function useresponsedata_callback(src,eventdata)%#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);

useresponsedata=findobj(handles.tabobjects,'tag','useresponsedata');

%set fakeax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.response=get(useresponsedata,'value'); %response check box value
set(handles.fakeax(handles.activeindex),'userdata',udata);

viewtabmenufilter(src,[])

function excludecheck_callback(src,eventdata) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

handles=guidata(src);

excludecheck=findobj(handles.tabobjects,'tag','excludecheck');

%set fakeax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.exclude=get(excludecheck,'value'); %exclude constant check box value
set(handles.fakeax(handles.activeindex),'userdata',udata);

viewtabmenufilter(src,[])



function countbutton_callback(src,eventdata) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);

set(src,'value',1)

probbutton=findobj(handles.tabobjects,'tag','probbutton');
set(probbutton,'value',0)

%set fakeax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.normalize=0; %exclude constant check box value
set(handles.fakeax(handles.activeindex),'userdata',udata);

%re-draw graph
xaxismenu_callback(handles.fig,[])



function probbutton_callback(src,eventdata) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);

set(src,'value',1)

countbutton=findobj(handles.tabobjects,'tag','countbutton');
set(countbutton,'value',0)

%set fakeax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.normalize=1; %exclude constant check box value
set(handles.fakeax(handles.activeindex),'userdata',udata);

%re-draw graph
xaxismenu_callback(handles.fig,[])

function outlierscheck_callback(src,eventdata) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%not implemented yet.


function statscheck_callback(src,eventdata) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);

%set fakeax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.showstats=get(src,'value'); %exclude constant check box value
set(handles.fakeax(handles.activeindex),'userdata',udata);

%re-draw graph
xaxismenu_callback(handles.fig,[])

