function formattaboverlayscatter(src,eventdata) %#ok<INUSD>
%rave format tab for line graphs.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata'); %i think the (1) is for if multiple graphs are selected.
format=udata.format; %get format tab structure.

%move front tabs to front if necessary
if handles.fronttabsfront==0 %move swap fronttabs and backtabs
    backpos=get(handles.backtabaxes,'position');
    frontpos=get(handles.fronttabaxes,'position');
    set(handles.fronttabaxes,'position',backpos)
    set(handles.backtabaxes,'position',frontpos)
    [x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
    set(handles.backtablines,'xdata',x,'ydata',y);
end
handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% clear existing tab
delete(handles.tabobjects)

%% text headers
graphtext=text(.15-.10317,.97*1.0317-.0317,'Graph','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
axestext=text(.15-.10317,.85*1.0317-.0317,'Axes','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
dataseriestext=text(.15-.10317,.515*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
legendtext=text(.15-.10317,.12*1.0317-.0317,'Legends','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

%% GRAPH UICONTROLS

bgtext=uicontrol('position',[origin(1)+25 origin(2)+575 180 20],...
    'style','text','string','Background Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
gridtext=uicontrol('position',[origin(1)+25 origin(2)+550 180 20],...
    'style','text','string','Grid Lines:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

%bgcolor=get(handles.fakerax(handles.activeindex),'color');

bgindex=eye(4);
bgin=format.bg;

% color blobs: (userdata = gridcolor; textcolor; index)
bgwhite=uicontrol('position',[origin(1)+155 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',[1 1 1],'value',bgindex(1,bgin),...
    'callback',@bgblob_callback,'userdata',[.6 .6 .6;0 0 0;1 0 0]);
bglight=uicontrol('position',[origin(1)+180 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',[.753 .753 .753],'value',bgindex(2,bgin),...
    'callback',@bgblob_callback,'userdata',[1 1 1;0 0 0;2 0 0]);
bgdark=uicontrol('position',[origin(1)+205 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',[.502 .502 .502],'value',bgindex(3,bgin),...
    'callback',@bgblob_callback,'userdata',[.6 .6 .6;1 1 1;3 0 0]);
bgblack=uicontrol('position',[origin(1)+230 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',[0 0 0],'value',bgindex(4,bgin),...
    'callback',@bgblob_callback,'userdata',[.3 .3 .3;1 1 1;4 0 0]);

handles.bgblobs=[bgwhite bglight bgdark bgblack];


gridindex=eye(3);
gridin=format.grid;


%grid radios
nogrid=uicontrol('position',[origin(1)+100 origin(2)+551 60 20],...
    'style','radiobutton','string','None','backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',gridindex(1,gridin),'callback',@nogrid_callback);
magrid=uicontrol('position',[origin(1)+152 origin(2)+551 60 20],...
    'style','radiobutton','string','Major','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',gridindex(2,gridin),'callback',@magrid_callback);
migrid=uicontrol('position',[origin(1)+204 origin(2)+551 55 20],...
    'style','radiobutton','string','Minor','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',gridindex(3,gridin),'callback',@migrid_callback);

handles.gridchecks=[nogrid magrid migrid];

%% Axes UICONTROLS

xlim=get(handles.activegraph,'xlim');
ylim=get(handles.activegraph,'ylim');

xlabeltext=uicontrol('position',[origin(1)+25 origin(2)+498 180 20],...
    'style','text','string','X Label:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
xlimtext=uicontrol('position',[origin(1)+35 origin(2)+474 180 20],...
    'style','text','string','Limits:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
xto=uicontrol('position',[origin(1)+158 origin(2)+474 20 20],...
    'style','text','string','to','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
xlabelbox=uicontrol('position',[origin(1)+85 origin(2)+500 160 20],...
    'style','edit','string',get(get(handles.activegraph,'xlabel'),'string'),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@xlabel_callback);
xminbox=uicontrol('position',[origin(1)+85 origin(2)+476 70 20],...
    'style','edit','string',xlim(1),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@xmin_callback,...
    'tag','xminbox');
xmaxbox=uicontrol('position',[origin(1)+175 origin(2)+476 70 20],...
    'style','edit','string',xlim(2),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@xmax_callback,...
    'tag','xmaxbox');
xresetbutton=uicontrol('position',[origin(1)+85 origin(2)+452 160 20],...
    'style','pushbutton','string','Reset X Axis Limits','backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold','callback',@xresetbutton_callback);

ylabeltext=uicontrol('position',[origin(1)+25 origin(2)+410 180 20],...
    'style','text','string','Y Label:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
ylimtext=uicontrol('position',[origin(1)+35 origin(2)+386 180 20],...
    'style','text','string','Limits:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
yto=uicontrol('position',[origin(1)+158 origin(2)+386 20 20],...
    'style','text','string','to','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
ylabelbox=uicontrol('position',[origin(1)+85 origin(2)+412 160 20],...
    'style','edit','string',get(get(handles.activegraph,'ylabel'),'string'),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@ylabel_callback);
yminbox=uicontrol('position',[origin(1)+85 origin(2)+388 70 20],...
    'style','edit','string',ylim(1),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@ymin_callback,...
    'tag','yminbox');
ymaxbox=uicontrol('position',[origin(1)+175 origin(2)+388 70 20],...
    'style','edit','string',ylim(2),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@ymax_callback,...
    'tag','ymaxbox');
yresetbutton=uicontrol('position',[origin(1)+85 origin(2)+364 160 20],...
    'style','pushbutton','string','Reset Y Axis Limits','backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold','callback',@yresetbutton_callback);


titletext=uicontrol('position',[origin(1)+25 origin(2)+332 180 20],...
    'style','text','string','Title:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
titlebox=uicontrol('position',[origin(1)+65 origin(2)+333 180 20],...
    'style','edit','string',get(get(handles.activegraph,'title'),'string'),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@title_callback);

%%  marker DATA SERIES UICONTROLS

markerstyletext=uicontrol('position',[origin(1)+50 origin(2)+280 49 20],...
    'style','text','string','Marker:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
markersizetext=uicontrol('position',[origin(1)+66 origin(2)+250 36 20],...
    'style','text','string','Size:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
markercolortext=uicontrol('position',[origin(1)+60 origin(2)+180 180 20],...
    'style','text','string','Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
selecttext=uicontrol('position',[origin(1)+21 origin(2)+120 180 20],...
    'style','text','string','Select Data:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

markerstyleaxes=axes('units','pixels','position',[origin(1)+102 origin(2)+282 144 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1]);
gap=.9/7;
%markerstyleoptions:
offcolor=[.9 .9 .9];
oncolor=handles.colors.text;

line(.05,.5,'marker','s','parent',markerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+gap,.5,'marker','o','parent',markerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+2*gap,.5,'marker','d','parent',markerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+3*gap,.5,'marker','^','parent',markerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+4*gap,.5,'marker','h','parent',markerstyleaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+5*gap,.5,'marker','p','parent',markerstyleaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+6*gap,.5,'marker','*','parent',markerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.95,.5,'marker','+','parent',markerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)

handles.styleblobs=get(markerstyleaxes,'children');
%color selected style:

hhh=findobj(handles.styleblobs,'marker',format.marker);
set(hhh,'markerfacecolor',oncolor);


markersizeaxes=axes('units','pixels','position',[origin(1)+100 origin(2)+277-25 144 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1],'parent',handles.fig);
%gap=.9/7;
%markersizeoptions:
line(.05,.5,'marker','s','parent',markersizeaxes,'markersize',1,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.12,.5,'marker','s','parent',markersizeaxes,'markersize',4,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.22,.5,'marker','s','parent',markersizeaxes,'markersize',5,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.33,.5,'marker','s','parent',markersizeaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.45,.5,'marker','s','parent',markersizeaxes,'markersize',10,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.59,.5,'marker','s','parent',markersizeaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.75,.5,'marker','s','parent',markersizeaxes,'markersize',14,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.95,.5,'marker','s','parent',markersizeaxes,'markersize',18,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)

handles.sizeblobs=get(markersizeaxes,'children');

%make size blobs the right style
set(handles.sizeblobs,'marker',format.marker)

%color the selected blob
hhh=findobj(handles.sizeblobs,'markersize',sqrt(format.minmarkersize));
set(hhh,'markerfacecolor',oncolor);

cdata=ravemakecdata(handles.fig,[],handles.cmapnames{udata.format.mcmap});

markercolor=uicontrol('position',[origin(1)+115 origin(2)+182 120 20],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','cdata',cdata,'callback',@mcolor_callback);

noisycolorcheck=uicontrol('position',[origin(1)+125 origin(2)+152 120 20],...
    'style','checkbox','string','Use Noisy Colors','value',format.ncolor,'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'horizontalalignment','left','callback',@ncolor_callback);

pointbutton=uicontrol('position',[origin(1)+115 origin(2)+119 26 26],...
    'style','togglebutton','string','','value',0,'backgroundcolor',handles.colors.togglebuttonbg,...
    'fontname','arial narrow','fontsize',6,'horizontalalignment','left','callback',@pointbutton_callback,...
    'cdata',imread('singlepoint.bmp'),'tag','pointbutton');

boxbutton=uicontrol('position',[origin(1)+145 origin(2)+119 26 26],...
    'style','togglebutton','string','','value',0,'backgroundcolor',handles.colors.togglebuttonbg,...
    'fontname','arial narrow','fontsize',6,'horizontalalignment','left','callback',@boxbutton_callback,...
    'cdata',imread('box.bmp'),'tag','boxbutton');

lassobutton=uicontrol('position',[origin(1)+175 origin(2)+119 26 26],...
    'style','togglebutton','string','','value',0,'backgroundcolor',handles.colors.togglebuttonbg,...
    'fontname','arial narrow','fontsize',6,'horizontalalignment','left','callback',@lassobutton_callback,...
    'cdata',imread('lasso.bmp'),'tag','lassobutton');

hidebutton=uicontrol('position',[origin(1)+222 origin(2)+119 26 26],...
    'style','pushbutton','string','','value',0,'backgroundcolor',handles.colors.togglebuttonbg,...
    'cdata',imread('hide.bmp'),'tooltip','Hide Selected Data','callback',@hidebutton_callback,'tag','hidebutton');

colortestbutton=zeros(1,10);
index=handles.prefs.rowcolors;
thecolors=get(handles.fig,'colormap');

for c=1:10
    colortestbutton(c)=uicontrol('position',[origin(1)+10+22*c origin(2)+85 18 18],...
    'style','pushbutton','string','','value',0,'backgroundcolor',thecolors(index(c),:),...
    'fontname','arial narrow','fontsize',6,'horizontalalignment','left',...
    'callback',@rowcolorblob_callback,'tag','rowcolorblob','userdata',c);

end

%% marker fill uicontrols:
markerfilltext=uicontrol('position',[origin(1)+74 origin(2)+215 29 20],...
    'style','text','string','Fill:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

markerfillaxes=axes('units','pixels','position',[origin(1)+132 origin(2)+217 80 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1]);
gap=.9/2;
%markerstyleoptions:
offcolor=[.6 .6 .6];
oncolor=handles.colors.text;

f1=line(.05,.5,'marker','p','parent',markerfillaxes,'markersize',16,'markerfacecolor',[1 1 1],...
    'markeredgecolor',offcolor,'buttondownfcn',@fillblob_callback,'userdata',1,'tag','fillblob');
f2=line(.05+gap,.5,'marker','p','parent',markerfillaxes,'markersize',16,'markerfacecolor',offcolor,...
    'markeredgecolor',offcolor,'buttondownfcn',@fillblob_callback,'userdata',2,'tag','fillblob');
f3=line(.95,.5,'marker','p','parent',markerfillaxes,'markersize',16,'markerfacecolor',offcolor,...
    'markeredgecolor',[0 0 0],'buttondownfcn',@fillblob_callback,'userdata',3,'tag','fillblob');

%handles.fillblobs=[f1 f2 f3];
%color selected style:
fillstyle=format.markerfill;
if fillstyle==1
    set(f1,'markeredgecolor',oncolor)
elseif fillstyle==2
    set(f2,'markerfacecolor',oncolor,'markeredgecolor',oncolor)
else %fillstyle=3
    set(f3,'markerfacecolor',oncolor)
end


%% legend uicontrols
% legendbutton=uicontrol('position',[origin(1)+115 origin(2)+68 160 20],...
%     'style','pushbutton','string','Format Legend','fontname','arial','fontsize',10,...
%     'backgroundcolor',handles.colors.buttonbg,'callback',@formatlegend_callback,...
%     'fontweight','bold');


legendcheck=uicontrol('position',[origin(1)+85 origin(2)+28 160 20],...
    'style','checkbox','string','Show Legend','fontname','arial narrow','fontsize',10,...
    'backgroundcolor',handles.colors.tabbg,'callback',@legendcheck_callback,...
    'fontweight','normal','horizontalalignment','left','value',0);

colorbarcheck=uicontrol('position',[origin(1)+85 origin(2)+6 160 20],...
    'style','checkbox','string','Show Colorbar','fontname','arial narrow','fontsize',10,...
    'backgroundcolor',handles.colors.tabbg,'callback',@colorbarcheck_callback,...
    'fontweight','normal','horizontalalignment','left','value',udata.format.colorbar);


%% group items and finish up
handles.tabobjects=[graphtext axestext dataseriestext bgtext gridtext bgwhite...
    bglight bgdark bgblack nogrid magrid migrid xlabeltext ylabeltext...
    xlimtext ylimtext xlabelbox ylabelbox xminbox yminbox xto xmaxbox...
    xresetbutton yto ymaxbox yresetbutton markerstyletext markersizetext markercolortext...
    markerstyleaxes markersizeaxes markercolor markerfilltext markerfillaxes...
    legendtext legendcheck titletext titlebox noisycolorcheck colorbarcheck boxbutton...
    lassobutton pointbutton selecttext hidebutton colortestbutton];

handles.activetab='format';

set(handles.infobar,'string','');

guidata(src,handles);

%% HERE BE CALLBACKS
%
%
%
%
%
%
%
%
%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function styleblob_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);

offcolor=[.9 .9 .9];
set(handles.styleblobs,'markerfacecolor',offcolor)
set(src,'markerfacecolor',handles.colors.text)
%update fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.marker=get(src,'marker');
set(handles.fakeax(handles.activeindex),'userdata',udata);


%get target data series
targets=get(handles.activegraph,'children');
%filter out line series with no marker
nottargets=findobj(targets,'type','line');
targets=setdiff(targets,nottargets);


targets=findobj(handles.activegraph,'tag','main','-or','tag','selected');

%update graph
set(targets,'marker',get(src,'marker'));
%update sizeblobs
set(handles.sizeblobs,'marker',get(src,'marker'));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function fillblob_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);

offcolor=[.6 .6 .6];
oncolor=handles.colors.text;

fillblobs=sort(findobj(handles.tabobjects,'tag','fillblob'));

set(fillblobs(1),'markeredgecolor',offcolor)
set(fillblobs(2),'markerfacecolor',offcolor,'markeredgecolor',offcolor)
set(fillblobs(3),'markerfacecolor',offcolor)

%get target data series
targets=findobj(get(handles.activegraph,'children'),'type','hggroup','tag','main');

fillstyle=get(src,'userdata');
if fillstyle==1
    set(targets,'markerfacecolor','none','markeredgecolor','flat');
    set(fillblobs(1),'markeredgecolor',oncolor)
elseif fillstyle==2
    set(targets,'markerfacecolor','flat','markeredgecolor','none');
    set(fillblobs(2),'markerfacecolor',oncolor,'markeredgecolor',oncolor)
else %fillstyle=3
    set(targets,'markerfacecolor','flat','markeredgecolor',[0 0 0]);
    set(fillblobs(3),'markerfacecolor',oncolor)
end

%update fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.markerfill=fillstyle;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function sizeblob_callback(src,eventdata) %#ok<INUSD>
%NOTE: for scatterplot, remake this to determine the size of the smallest
%marker.
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

offcolor=[.9 .9 .9];
oncolor=handles.colors.text;


%get target data series
maintarget=findobj(get(handles.activegraph,'children'),'tag','main');
selectedtarget=findobj(get(handles.activegraph,'children'),'tag','selected');
%get new size:
newsize=get(src,'markersize')^2;

if strcmp(get(gcf,'selectiontype'),'alt')
    if newsize>udata.format.minmarkersize
        udata.format.maxmarkersize=newsize;
    else
        return
    end
else
    udata.format.minmarkersize=newsize;
    udata.format.maxmarkersize=625;
    set(handles.sizeblobs,'markerfacecolor',offcolor)
    set(src,'markerfacecolor',oncolor)
end

nothidden=handles.isvisible{udata.view.dataset}{udata.view.analysis};

%update graph
%s=get(targets,'sizedata');

x=handles.alldata{udata.view.dataset}(nothidden,udata.view.x); %just use this to get numrows.

if udata.view.s~=0
    set(handles.infobar,'string','Click to set min size, ctrl-click to set max size.')
    isallonesize=0;
    s=handles.alldata{udata.view.dataset}(nothidden,udata.view.s);
    minsize=udata.format.minmarkersize;
    maxsize=udata.format.maxmarkersize;
    s=(((s-min(s))/(max(s)-min(s))).^2)*maxsize + minsize + rand(length(x),1)/100;
else

    s=ones(length(x),1);
    isallonesize=1;

    %     if udata.format.markerfill==3 %force to draw each marker as its own patch for proper zbuffer rendering.
    %         s=(1:length(x))';
    %     end
end



minsize=udata.format.minmarkersize;
if isallonesize
    set(get(maintarget,'children'),'markersize',sqrt(minsize));
    set(get(selectedtarget,'children'),'markersize',sqrt(minsize));
else
    set(maintarget,'sizedata',s);
    set(selectedtarget,'sizedata',s(handles.isselected{udata.view.dataset}{udata.view.analysis}));

end

%store this size in userdata:
set(handles.fakeax(handles.activeindex),'userdata',udata);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function bgblob_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);

uicontrol(handles.dummyobj)

colors=get(src,'userdata');
gridcolor=colors(1,:);
%textcolor=colors(2,:);

plotcolor=get(src,'backgroundcolor');

%update fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.bg=colors(3,1);
set(handles.fakeax(handles.activeindex),'userdata',udata);

%unpop blobs:
set(handles.bgblobs,'value',0);
set(src,'value',1)

%change colors
set(handles.fakerax(handles.activeindex),'color',plotcolor,'xcolor',gridcolor,'ycolor',gridcolor)
set(handles.fakeax(handles.activeindex),'xcolor',gridcolor,'ycolor',gridcolor);

%fix tick marks
if all(plotcolor==[0 0 0])
    set(handles.activegraph,'ticklength',[0 0])
else
    set(handles.activegraph,'tickdir','in','ticklength',[.01 .025])
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function magrid_callback(src, eventdata) %#ok<INUSD>
handles=guidata(src);
%inputs=get(handles.fakerax{handles.activeindex},'userdata');

set(handles.gridchecks,'value',0)
set(src,'value',1)

%updata fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.grid=2;
set(handles.fakeax(handles.activeindex),'userdata',udata);

set(handles.fakerax(handles.activeindex),'XGrid','on','YGrid','on')
set(handles.fakerax(handles.activeindex),'XminorGrid','off','YminorGrid','off')
set(handles.fakeax(handles.activeindex),'XGrid','off','YGrid','off')

function migrid_callback(src, eventdata) %#ok<INUSD>
handles=guidata(src);

set(handles.gridchecks,'value',0)
set(src,'value',1)


%updata fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.grid=3;
set(handles.fakeax(handles.activeindex),'userdata',udata);

set(handles.fakerax(handles.activeindex),'XminorGrid','on','YminorGrid','on')
set(handles.fakerax(handles.activeindex),'XGrid','off','YGrid','off')
set(handles.fakeax(handles.activeindex),'XGrid','on','YGrid','on')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function nogrid_callback(src, eventdata) %#ok<INUSD>
handles=guidata(src);

set(handles.gridchecks,'value',0)
set(src,'value',1)

%updata fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.grid=1;
set(handles.fakeax(handles.activeindex),'userdata',udata);


set(handles.fakerax(handles.activeindex),'XminorGrid','off','YminorGrid','off')
set(handles.fakerax(handles.activeindex),'XGrid','off','YGrid','off')
set(handles.fakeax(handles.activeindex),'XGrid','off','YGrid','off')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function xmin_callback(src, eventdata) %#ok<INUSD>

handles=guidata(src);
newval=eval(get(src,'string'));
xlim=get(handles.activegraph,'xlim');
xlim(1)=newval;
set(handles.activegraph,'xlim',xlim)
set(handles.fakeax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))
set(handles.fakerax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xmax_callback(src, eventdata) %#ok<INUSD>

handles=guidata(src);
newval=eval(get(src,'string'));
xlim=get(handles.activegraph,'xlim');
xlim(2)=newval;
set(handles.activegraph,'xlim',xlim)
set(handles.fakeax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))
set(handles.fakerax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ymin_callback(src, eventdata) %#ok<INUSD>

handles=guidata(src);
newval=eval(get(src,'string'));
ylim=get(handles.activegraph,'ylim');
ylim(1)=newval;
set(handles.activegraph,'ylim',ylim)
set(handles.fakeax(handles.activeindex),'ylim',ylim,'xlim',get(handles.activegraph,'xlim'))
set(handles.fakerax(handles.activeindex),'ylim',ylim,'xlim',get(handles.activegraph,'xlim'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ymax_callback(src, eventdata) %#ok<INUSD>

handles=guidata(src);
newval=eval(get(src,'string'));
ylim=get(handles.activegraph,'ylim');
ylim(2)=newval;
set(handles.activegraph,'ylim',ylim)
set(handles.fakeax(handles.activeindex),'ylim',ylim,'xlim',get(handles.activegraph,'xlim'))
set(handles.fakerax(handles.activeindex),'ylim',ylim,'xlim',get(handles.activegraph,'xlim'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xresetbutton_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
set(handles.activegraph,'xlimmode','auto')
xlim=get(handles.activegraph,'xlim');

set(handles.fakeax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))
set(handles.fakerax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))

xminbox=findobj(handles.tabobjects,'tag','xminbox');
xmaxbox=findobj(handles.tabobjects,'tag','xmaxbox');

set(xminbox,'string',num2str(xlim(1)))
set(xmaxbox,'string',num2str(xlim(2)))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function yresetbutton_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
set(handles.activegraph,'ylimmode','auto')
ylim=get(handles.activegraph,'ylim');

set(handles.fakeax(handles.activeindex),'ylim',ylim,'xlim',get(handles.activegraph,'xlim'))
set(handles.fakerax(handles.activeindex),'ylim',ylim,'xlim',get(handles.activegraph,'xlim'))

yminbox=findobj(handles.tabobjects,'tag','yminbox');
ymaxbox=findobj(handles.tabobjects,'tag','ymaxbox');

set(yminbox,'string',num2str(ylim(1)))
set(ymaxbox,'string',num2str(ylim(2)))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xlabel_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
set(get(handles.activegraph,'xlabel'),'string',get(src,'string'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ylabel_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
set(get(handles.activegraph,'ylabel'),'string',get(src,'string'))
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function mcolor_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

newcmap=ravechoosecolormap(src,[],udata.format.mcmap);


if newcmap==udata.format.mcmap;return;end

udata.format.mcmap=newcmap;


colorz=handles.cmapnames;
newcolormap=colorz{newcmap};

cdata=ravemakecdata(handles.fig,[],newcolormap);
set(src,'cdata',cdata);


main=findobj(handles.activegraph,'tag','main');
selected=findobj(handles.activegraph,'tag','selected');


nothidden=handles.isvisible{udata.view.dataset}{udata.view.analysis};

if udata.view.c~=0
    c=handles.alldata{udata.view.dataset}(nothidden,udata.view.c);
    %normalize cdata to desired colormap:
    c=(c-min(c))/(max(c)-min(c))*127+1+128*(newcmap-1);

    set(main,'cdata',c);
end


minsize=udata.format.minmarkersize;
if udata.view.s==0
    set(get(main,'children'),'markersize',sqrt(minsize));
    set(get(selected,'children'),'markersize',sqrt(minsize));
end

set(handles.fakeax(handles.activeindex),'userdata',udata);

if udata.format.colorbar;
    if udata.view.c     
        ravefixcolorbar(handles.fig,[]);
    end
end



% function colorpopup_callback(src,eventdata)
% damenu=findobj(get(src,'parent'),'tag','colormenu');
% 
% set(0,'userdata',[]);
% if strcmp(get(src,'string'),'Ok')
%     set(0,'userdata',get(damenu,'value'));
% end
% 
% close(get(gcbo,'parent'))


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function mcheck_callback(src,eventdata) %#ok<INUSD,DEFNU>
handles=guidata(src);

%get target data series
targets=get(handles.activegraph,'children');
%filter out line series with no marker
nottargets=findobj(targets,'marker','none');
targets=setdiff(targets,nottargets);

if get(src,'value') %turn markers on
    set(targets,'visible','on');
else
    set(targets,'visible','off');
end

%update userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.mcheck=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function title_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
set(get(handles.activegraph,'title'),'string',get(src,'string'),'fontsize',14);
raveresizeaxes(src,[],handles.activeindex);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
function formatlegend_callback(src,eventdata)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
function ncolor_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);



udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.ncolor=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);


%maintain selection:
maindata=findobj(handles.activegraph,'tag','main');
selected=findobj(handles.activegraph,'tag','selected');
inpoints=get(selected,'userdata');
handles.temp.selected=findobj(handles.activegraph,'tag','selected');
handles.temp.main=findobj(handles.activegraph,'tag','main');
handles.temp.xdata=get(maindata,'xdata');
handles.temp.ydata=get(maindata,'ydata');
handles.temp.cdata=get(maindata,'cdata');
handles.temp.sdata=get(maindata,'sizedata');
%set(handles.temp.selected,'visible','off','userdata',false(size(handles.temp.xdata)));


ravecreatescatter(handles.fig,[]);

selected=findobj(handles.activegraph,'tag','selected');
if any(inpoints)
    set(selected,'xdata',handles.temp.xdata(inpoints),'ydata',handles.temp.ydata(inpoints),...
        'cdata',handles.temp.cdata(inpoints),'sizedata',handles.temp.sdata(inpoints),'visible','on','userdata',inpoints);
    if udata.view.s==0 %isallonesize
        set(get(selected,'children'),'markersize',sqrt(udata.format.minmarkersize));
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function colorbarcheck_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
legdata=get(handles.fakerax(handles.activeindex),'userdata');

if get(src,'value')
    if udata.view.c
        udata.format.colorbar=1;
        set(handles.fakeax(handles.activeindex),'userdata',udata);
        ravefixcolorbar(handles.fig,[]);

    end
else

    %check for existing colorbar:
    cbar=findobj('tag','Colorbar','userdata',handles.activeindex);
    if ~isempty(cbar)
        legdata=setdiff(legdata,cbar);
    end
    %turn if off:
    colorbar('off','peer',handles.activegraph);
    udata.format.colorbar=0;

end

set(handles.fakeax(handles.activeindex),'userdata',udata);
set(handles.fakerax(handles.activeindex),'userdata',legdata);

ravecreatescatter(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function pointbutton_callback(src,ev) %#ok<INUSD>
handles=guidata(src);

otherbuttons=findobj(handles.tabobjects,'tag','lassobutton','-or','tag','boxbutton');
set(otherbuttons,'value',0);


if get(src,'value')
    set(get(handles.activegraph,'children'),'HitTest','on','ButtonDownFcn',@pointselect)
    set(handles.activegraph,'HitTest','on','ButtonDownFcn',@boxstart) %this allows for deselecting all points by clicking anywhere.
else
    set(get(handles.activegraph,'children'),'hittest','off','ButtonDownFcn','')
    set(handles.activegraph,'HitTest','on','ButtonDownFcn','')
end

function boxbutton_callback(src,ev)%#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);
otherbuttons=findobj(handles.tabobjects,'tag','lassobutton','-or','tag','pointbutton');
set(otherbuttons,'value',0);

if get(src,'value')
    set(handles.activegraph,'HitTest','on','ButtonDownFcn',@boxstart)
    set(get(handles.activegraph,'children'),'HitTest','off','ButtonDownFcn','')
else
    set(handles.activegraph,'HitTest','off','ButtonDownFcn','','color','none')
    set(get(handles.activegraph,'children'),'HitTest','off','ButtonDownFcn','')
end

function lassobutton_callback(src,ev) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);
otherbuttons=findobj(handles.tabobjects,'tag','boxbutton','-or','tag','pointbutton');
set(otherbuttons,'value',0);

if get(src,'value')
    set(handles.activegraph,'HitTest','on','ButtonDownFcn',@lassostart)
    set(get(handles.activegraph,'children'),'HitTest','off','ButtonDownFcn','')
else
    set(handles.activegraph,'HitTest','off','ButtonDownFcn','','color','none')
    set(get(handles.activegraph,'children'),'HitTest','off','ButtonDownFcn','')
end

function pointselect(src,ev) %#ok<INUSD>
%determine which point was clicked:
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
handles.temp.selected=findobj(handles.activegraph,'tag','selected');

clicked=get(handles.activegraph,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);

%convert xclick/yclick to pixels.
xdata=get(src,'xdata');
ydata=get(src,'ydata');
cdata=get(src,'cdata');
sdata=get(src,'sizedata');

inpoints=ravefindclosestpoint2D(xclick,yclick,src);

%need to set all data properties so dimensions are correct.
set(handles.temp.selected,'xdata',xdata(inpoints),'ydata',ydata(inpoints),...
    'cdata',cdata(inpoints),'sizedata',sdata(inpoints),'visible','on','userdata',inpoints);
if udata.view.s==0 %isallonesize
    set(get(handles.temp.selected,'children'),'markersize',sqrt(udata.format.minmarkersize));
end

handles.isselected{udata.view.dataset}{udata.view.analysis}=get(handles.temp.selected,'userdata');
guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected');


function boxstart(src,ev) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
%set(handles.fig,'windowbuttondownfcn',[]);

%check that they clicked on current graph:
if gco~=handles.activegraph
    return
end

clicked=get(handles.activegraph,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

handles.temp.selection=rectangle('position',[xclick yclick eps eps],'linewidth',1,'edgecolor',[1 .5 0],...
    'parent',handles.activegraph,'hittest','off','buttondownfcn','','facecolor','none','clipping','on');
maindata=findobj(handles.activegraph,'tag','main');
%set(maindata,'visible','off');

handles.temp.selected=findobj(handles.activegraph,'tag','selected');
handles.temp.main=findobj(handles.activegraph,'tag','main');
handles.temp.xdata=get(maindata,'xdata');
handles.temp.ydata=get(maindata,'ydata');
handles.temp.cdata=get(maindata,'cdata');
handles.temp.sdata=get(maindata,'sizedata');


handles.temp.xdata=handles.alldata{udata.view.dataset}(:,udata.view.x);
handles.temp.ydata=handles.alldata{udata.view.dataset}(:,udata.view.y);


if udata.view.c~=0
    handles.temp.cdata=handles.alldata{udata.view.dataset}(:,udata.view.c);
else
    if udata.format.ncolor
        handles.temp.cdata=rand(length(handles.temp.xdata),1)-.5; %noisy colors
    else
        handles.temp.cdata=zeros(length(handles.temp.xdata),1); %non-noisy colors cdata=0.5
    end
end

if udata.view.s~=0
    s=handles.alldata{udata.view.dataset}(:,udata.view.s);
    isallonesize=0;
    minsize=udata.format.minmarkersize;
    maxsize=udata.format.maxmarkersize;
    handles.temp.sdata=(((s-min(s))/(max(s)-min(s))).^2)*maxsize + minsize + rand(length(handles.temp.xdata),1)/100;
else
    handles.temp.sdata=ones(length(handles.temp.xdata),1);
    isallonesize=1;
end

set(handles.temp.selected,'visible','off','userdata',false(size(handles.temp.xdata)));

%maintain manual/auto sizing:
handles.temp.axesmode=get(handles.activegraph,'xlimmode');
set(handles.activegraph,'xlimmode','manual','ylimmode','manual');

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@ravesizeselection);
set(handles.fig,'WindowButtonUpFcn',@ravesizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);

guidata(src,handles);

function ravesizeselection(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%if in pointselect mode, dont allow sizing, just go straight to buttonupfcn.
maindata=findobj(handles.activegraph,'tag','main');
if ~isempty(get(maindata,'buttondownfcn'))
    if strcmp(func2str(get(maindata,'buttondownfcn')),'pointselect')
        return
    end
end

finish=get(handles.activegraph,'currentpoint');
starty=handles.temp.starty;
startx=handles.temp.startx;
endx=finish(1,1,1);
endy=finish(1,2,1);

pos1=min(startx,endx);
pos3=max(startx,endx)-pos1;
pos2=min(starty,endy);
pos4=max(starty,endy)-pos2;

try %#ok<TRYNC>
    set(handles.temp.selection,'position',[pos1 pos2 pos3 pos4]);
end
%determine which points are in this rectangle:

%inpoints=find(inpolygon(handles.temp.xdata,handles.temp.ydata,[pos1 pos1 pos1+pos3 pos1+pos3],[pos2 pos2+pos4 pos2+pos4 pos2]));
inpoints=inpolygon(handles.temp.xdata,handles.temp.ydata,[pos1 pos1 pos1+pos3 pos1+pos3],[pos2 pos2+pos4 pos2+pos4 pos2]);


inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};


if ~any(inpoints)
    set(handles.temp.selected,'visible','off','userdata',false(size(handles.temp.xdata)))
else
    %need to set all data properties so dimensions are correct.
    set(handles.temp.selected,'xdata',handles.temp.xdata(inpoints),'ydata',handles.temp.ydata(inpoints),...
        'cdata',handles.temp.cdata(inpoints),'sizedata',handles.temp.sdata(inpoints),'visible','on','userdata',inpoints);
    if udata.view.s==0 %isallonesize
        set(get(handles.temp.selected,'children'),'markersize',sqrt(udata.format.minmarkersize));
    end




end

function ravesizeselectiondone(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',[]);
set(handles.fig,'WindowButtonUpFcn',[]);
set(handles.activegraph,'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)
%set(handles.temp.main,'visible','on');

delete(handles.temp.selection);

%store indices of selected points.
inpoints=get(handles.temp.selected,'userdata');

handles.isselected{udata.view.dataset}{udata.view.analysis}=get(handles.temp.selected,'userdata');
set(handles.fakeax(handles.activeindex),'userdata',udata);
guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected');


function lassostart(src,ev) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
%set(handles.fig,'windowbuttondownfcn',[]);

%check that they clicked on current graph:
if gco~=handles.activegraph
    return
end

clicked=get(handles.activegraph,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.xpoints=xclick;
handles.temp.ypoints=yclick;
%fill color:
% handles.temp.selection=fill(xclick, yclick,get(handles.fakerax(handles.activeindex),'color'),'linewidth',1,'edgecolor',[1 .5 0],...
%     'parent',handles.activegraph,'hittest','off','buttondownfcn','','clipping','on');
handles.temp.selection=patch(xclick, yclick,get(handles.fakerax(handles.activeindex),'color'),'linewidth',1,'edgecolor',[1 .5 0],...
    'parent',handles.activegraph,'hittest','off','buttondownfcn','','clipping','on');

uistack(handles.temp.selection,'bottom');
maindata=findobj(handles.activegraph,'tag','main');
%set(maindata,'visible','off');

handles.temp.selected=findobj(handles.activegraph,'tag','selected');
handles.temp.main=findobj(handles.activegraph,'tag','main');
handles.temp.xdata=get(maindata,'xdata');
handles.temp.ydata=get(maindata,'ydata');
handles.temp.cdata=get(maindata,'cdata');
handles.temp.sdata=get(maindata,'sizedata');

handles.temp.xdata=handles.alldata{udata.view.dataset}(:,udata.view.x);
handles.temp.ydata=handles.alldata{udata.view.dataset}(:,udata.view.y);


if udata.view.c~=0
    handles.temp.cdata=handles.alldata{udata.view.dataset}(:,udata.view.c);
else
    if udata.format.ncolor
        handles.temp.cdata=rand(length(handles.temp.xdata),1)-.5; %noisy colors
    else
        handles.temp.cdata=zeros(length(handles.temp.xdata),1); %non-noisy colors cdata=0.5
    end
end

if udata.view.s~=0
    s=handles.alldata{udata.view.dataset}(:,udata.view.s);
    isallonesize=0;
    minsize=udata.format.minmarkersize;
    maxsize=udata.format.maxmarkersize;
    handles.temp.sdata=(((s-min(s))/(max(s)-min(s))).^2)*maxsize + minsize + rand(length(handles.temp.xdata),1)/100;
else
    handles.temp.sdata=ones(length(handles.temp.xdata),1);
    isallonesize=1;
end

set(handles.temp.selected,'visible','off','userdata',false(size(handles.temp.xdata)));



%maintain manual/auto sizing:
handles.temp.axesmode=get(handles.activegraph,'xlimmode');
set(handles.activegraph,'xlimmode','manual','ylimmode','manual');

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@ravesizelasso);
set(handles.fig,'WindowButtonUpFcn',@ravesizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);

guidata(src,handles);

function ravesizelasso(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

mousenew = get(handles.activegraph,'CurrentPoint');
mousenew = mousenew(1,1:2);

% append the new point on the end of the last lasso
handles.temp.xpoints = [get(handles.temp.selection,'xdata');mousenew(1,1)];
handles.temp.ypoints = [get(handles.temp.selection,'ydata');mousenew(1,2)];

% replot the newly extended lasso
set(handles.temp.selection,'xdata',handles.temp.xpoints,'ydata',handles.temp.ypoints)

%determine which points are in this region:
%inpoints=find(inpolygon(handles.temp.xdata,handles.temp.ydata,handles.temp.xpoints,handles.temp.ypoints));
inpoints=inpolygon(handles.temp.xdata,handles.temp.ydata,handles.temp.xpoints,handles.temp.ypoints);
inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};

nothidden=handles.isvisible{udata.view.dataset}{udata.view.analysis};


if ~any(inpoints)
    set(handles.temp.selected,'visible','off','userdata',false(size(handles.temp.xdata)))
else
    %need to set all data properties so dimensions are correct.
    set(handles.temp.selected,'xdata',handles.temp.xdata(inpoints),'ydata',handles.temp.ydata(inpoints),...
        'cdata',handles.temp.cdata(inpoints),'sizedata',handles.temp.sdata(inpoints),'visible','on','userdata',inpoints);
    if udata.view.s==0 %isallonesize
        set(get(handles.temp.selected,'children'),'markersize',sqrt(udata.format.minmarkersize));
    end

end


function hidebutton_callback(src,ev) %#ok<INUSD>
%hide the selected points
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

nothidden=handles.isvisible{udata.view.dataset}{udata.view.analysis};

newhidden=false(size(nothidden));
newhidden(handles.isselected{udata.view.dataset}{udata.view.analysis})=true;

allhidden= ~nothidden | newhidden;

handles.isvisible{udata.view.dataset}{udata.view.analysis}=~allhidden;

%set(handles.fakeax(handles.activeindex),'userdata',udata);

%now apply this change:

x=handles.alldata{udata.view.dataset}(:,udata.view.x);
y=handles.alldata{udata.view.dataset}(:,udata.view.y);


if udata.view.c~=0
    c=handles.alldata{udata.view.dataset}(:,udata.view.c);
    %normalize cdata to desired colormap:
    c=(c-min(c))/(max(c)-min(c))*127+128*(udata.format.mcmap-1)+1; 
else
    if udata.format.ncolor
         c=handles.prefs.rowcolors(handles.rowcolors{udata.view.dataset}{udata.view.analysis})'+10*rand(length(x),1)-.5; %noisy colors
    else
         c=handles.prefs.rowcolors(handles.rowcolors{udata.view.dataset}{udata.view.analysis})'; %non-noisy colors cdata=0.5 
    end
end


set(handles.activegraph,'climmode','manual','clim',[1 size(get(handles.fig,'colormap'),1)]);



if udata.view.s~=0
    s=handles.alldata{udata.view.dataset}(:,udata.view.s);
    isallonesize=0;
    minsize=udata.format.minmarkersize;
    maxsize=udata.format.maxmarkersize;
    s=(((s-min(s))/(max(s)-min(s))).^2)*maxsize + minsize + rand(length(x),1)/100;
else
    s=ones(length(x),1);
    isallonesize=1;
end


main=findobj(handles.activegraph,'tag','main');
selected=findobj(handles.activegraph,'tag','selected');

set(main,'xdata',x(~allhidden),'ydata',y(~allhidden),'cdata',c(~allhidden),'sizedata',s(~allhidden));
set(selected,'xdata',[],'ydata',[],'zdata',[],'sizedata',[])

minsize=udata.format.minmarkersize;
if isallonesize
    set(get(main,'children'),'markersize',sqrt(minsize)) ;
    set(get(selected,'children'),'markersize',sqrt(minsize)) ;
end


guidata(src,handles);

function rowcolorblob_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

oldindex=get(src,'userdata');

if strcmp(get(handles.fig,'currentmodifier'),'control')
    newindex=ravechoosecolormapcolor(handles.fig,[],oldindex);
    handles.prefs.rowcolors(get(src,'userdata'))=newindex;  
    
    thecolors=get(handles.fig,'colormap');
    set(src,'backgroundcolor',thecolors(newindex,:));
    
    
else
    newindex=oldindex;
end

handles.rowcolors{udata.view.dataset}{udata.view.analysis}(handles.isselected{udata.view.dataset}{udata.view.analysis})=get(src,'userdata');

guidata(handles.fig,handles);

ravecreatescatter(src,[]);

raveupdateanalysis(src,[],'rowcolors');



function legendcheck_callback(src,ev)

