function formattabgoodness(src,eventdata)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%rave format tab.


handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
format=udata.format; %get format tab structure.

%move front tabs to front if necessary
if handles.fronttabsfront==0 %move swap fronttabs and backtabs
    backpos=get(handles.backtabaxes,'position');
    frontpos=get(handles.fronttabaxes,'position');
    set(handles.fronttabaxes,'position',backpos)
    set(handles.backtabaxes,'position',frontpos)
    [x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0);
    set(handles.backtablines,'xdata',x,'ydata',y);       
end
handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1);
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% clear existing tab
delete(handles.tabobjects)

%% text headers 
graphtext=text(.15-.10317,.97*1.0317-.0317,'Graph','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
axestext=text(.15-.10317,.85*1.0317-.0317,'Axes','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
dataseriestext=text(.15-.10317,.75*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
% legendtext=text(.15,.10,'Legends','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
%     'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);


bgtext=uicontrol('position',[origin(1)+25 origin(2)+575 180 20],...
    'style','text','string','Background Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
gridtext=uicontrol('position',[origin(1)+25 origin(2)+550 180 20],...
    'style','text','string','Grid Lines:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

%bgcolor=get(handles.fakerax(handles.activeindex),'color');

bgindex=eye(4);
bgin=format.bg;

% color blobs: (userdata = gridcolor; textcolor; index)
bgwhite=uicontrol('position',[origin(1)+155 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',[1 1 1],'value',bgindex(1,bgin),...
    'callback',@bgblob_callback,'userdata',[.6 .6 .6;0 0 0;1 0 0]);
bglight=uicontrol('position',[origin(1)+180 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',[.753 .753 .753],'value',bgindex(2,bgin),...
    'callback',@bgblob_callback,'userdata',[1 1 1;0 0 0;2 0 0]);
bgdark=uicontrol('position',[origin(1)+205 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',[.502 .502 .502],'value',bgindex(3,bgin),...
    'callback',@bgblob_callback,'userdata',[.6 .6 .6;1 1 1;3 0 0]);
bgblack=uicontrol('position',[origin(1)+230 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',[0 0 0],'value',bgindex(4,bgin),...
    'callback',@bgblob_callback,'userdata',[.3 .3 .3;1 1 1;4 0 0]);

handles.bgblobs=[bgwhite bglight bgdark bgblack];


gridindex=eye(3);
gridin=format.grid;


%grid radios
nogrid=uicontrol('position',[origin(1)+100 origin(2)+551 60 20],...
    'style','radiobutton','string','None','backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',gridindex(1,gridin),'callback',@nogrid_callback);
magrid=uicontrol('position',[origin(1)+152 origin(2)+551 60 20],...
    'style','radiobutton','string','Major','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',gridindex(2,gridin),'callback',@magrid_callback);
migrid=uicontrol('position',[origin(1)+204 origin(2)+551 55 20],...
    'style','radiobutton','string','Minor','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',gridindex(3,gridin),'callback',@migrid_callback);

handles.gridchecks=[nogrid magrid migrid];


%% title:

if udata.view.graphs==5
    titel=findobj(handles.activegraph,'tag','title');
else
    titel=get(handles.subax{handles.activeindex}(1),'title');
end


titletext=uicontrol('position',[origin(1)+25 origin(2)+332+165 180 20],...
    'style','text','string','Title:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
titlebox=uicontrol('position',[origin(1)+65 origin(2)+333+165 180 20],...
    'style','edit','string',get(titel,'string'),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@title_callback);






%% marker formatting

fittext=uicontrol('position',[origin(1)+25 origin(2)+430 180 20],...
    'style','text','string','Fit Data Markers','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');


fitmarkerstyletext=uicontrol('position',[origin(1)+50 origin(2)+280+125 49 20],...
    'style','text','string','Marker:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
fitmarkersizetext=uicontrol('position',[origin(1)+66 origin(2)+250+125 36 20],...
    'style','text','string','Size:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
fitmarkercolortext=uicontrol('position',[origin(1)+60 origin(2)+220+125 180 20],...
    'style','text','string','Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
% selecttext=uicontrol('position',[origin(1)+51 origin(2)+140 180 20],...
%     'style','text','string','Select Data:','backgroundcolor',handles.colors.tabbg,...
%     'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

fitmarkerstyleaxes=axes('units','pixels','position',[origin(1)+112 origin(2)+282+125 144 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1],'tag','fitstyleaxes');
gap=.9/7;
%markerstyleoptions:
offcolor=[.9 .9 .9];
oncolor=handles.colors.text;

line(.05,.5,'marker','s','parent',fitmarkerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+gap,.5,'marker','o','parent',fitmarkerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+2*gap,.5,'marker','d','parent',fitmarkerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+3*gap,.5,'marker','^','parent',fitmarkerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+4*gap,.5,'marker','h','parent',fitmarkerstyleaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+5*gap,.5,'marker','p','parent',fitmarkerstyleaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+6*gap,.5,'marker','*','parent',fitmarkerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.95,.5,'marker','+','parent',fitmarkerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)

handles.styleblobs=get(fitmarkerstyleaxes,'children');
%color selected style:

hhh=findobj(handles.styleblobs,'marker',format.fitmarker);
set(hhh,'markerfacecolor',oncolor);


fitmarkersizeaxes=axes('units','pixels','position',[origin(1)+100 origin(2)+277-25+125 144 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1],'parent',handles.fig,'tag','fitsizeaxes');
%gap=.9/7;
%markersizeoptions:
line(.05,.5,'marker','s','parent',fitmarkersizeaxes,'markersize',1,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.12,.5,'marker','s','parent',fitmarkersizeaxes,'markersize',2,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.22,.5,'marker','s','parent',fitmarkersizeaxes,'markersize',4,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.33,.5,'marker','s','parent',fitmarkersizeaxes,'markersize',5,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.45,.5,'marker','s','parent',fitmarkersizeaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.59,.5,'marker','s','parent',fitmarkersizeaxes,'markersize',10,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.75,.5,'marker','s','parent',fitmarkersizeaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.95,.5,'marker','s','parent',fitmarkersizeaxes,'markersize',14,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)

handles.sizeblobs=get(fitmarkersizeaxes,'children');

%make size blobs the right style
set(handles.sizeblobs,'marker',format.fitmarker)

%color the selected blob
hhh=findobj(handles.sizeblobs,'markersize',format.fitmarkersize);
set(hhh,'markerfacecolor',oncolor);

%cdata=ravemakecdata(handles.fig,[],handles.cmapnames{udata.format.mcmap});

fitmarkercolor=uicontrol('position',[origin(1)+115 origin(2)+222+125 22 22],...
    'style','pushbutton','string','','backgroundcolor',format.markerfitcolor,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@mcolor_callback,'tag','fitmarkercolor');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


unfittext=uicontrol('position',[origin(1)+25 origin(2)+430-120 180 20],...
    'style','text','string','Test Data Markers','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');


unfitmarkerstyletext=uicontrol('position',[origin(1)+50 origin(2)+280+125-120 49 20],...
    'style','text','string','Marker:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
unfitmarkersizetext=uicontrol('position',[origin(1)+66 origin(2)+250+125-120 36 20],...
    'style','text','string','Size:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
unfitmarkercolortext=uicontrol('position',[origin(1)+60 origin(2)+220+125-120 180 20],...
    'style','text','string','Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
% selecttext=uicontrol('position',[origin(1)+51 origin(2)+140 180 20],...
%     'style','text','string','Select Data:','backgroundcolor',handles.colors.tabbg,...
%     'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

unfitmarkerstyleaxes=axes('units','pixels','position',[origin(1)+102 origin(2)+287 144 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1],'tag','unfitstyleaxes');
gap=.9/7;
%markerstyleoptions:
offcolor=[.9 .9 .9];
oncolor=handles.colors.text;

line(.05,.5,'marker','s','parent',unfitmarkerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+gap,.5,'marker','o','parent',unfitmarkerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+2*gap,.5,'marker','d','parent',unfitmarkerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+3*gap,.5,'marker','^','parent',unfitmarkerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+4*gap,.5,'marker','h','parent',unfitmarkerstyleaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+5*gap,.5,'marker','p','parent',unfitmarkerstyleaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.05+6*gap,.5,'marker','*','parent',unfitmarkerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)
line(.95,.5,'marker','+','parent',unfitmarkerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback)

handles.styleblobs=get(unfitmarkerstyleaxes,'children');
%color selected style:

hhh=findobj(handles.styleblobs,'marker',format.unfitmarker);
set(hhh,'markerfacecolor',oncolor);


unfitmarkersizeaxes=axes('units','pixels','position',[origin(1)+100 origin(2)+257 144 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1],'parent',handles.fig,'tag','unfitsizeaxes');
%gap=.9/7;
%markersizeoptions:
line(.05,.5,'marker','s','parent',unfitmarkersizeaxes,'markersize',1,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.12,.5,'marker','s','parent',unfitmarkersizeaxes,'markersize',2,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.22,.5,'marker','s','parent',unfitmarkersizeaxes,'markersize',4,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.33,.5,'marker','s','parent',unfitmarkersizeaxes,'markersize',5,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.45,.5,'marker','s','parent',unfitmarkersizeaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.59,.5,'marker','s','parent',unfitmarkersizeaxes,'markersize',10,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.75,.5,'marker','s','parent',unfitmarkersizeaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)
line(.95,.5,'marker','s','parent',unfitmarkersizeaxes,'markersize',14,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback)

handles.sizeblobs=get(unfitmarkersizeaxes,'children');

%make size blobs the right style
set(handles.sizeblobs,'marker',format.unfitmarker)

%color the selected blob
hhh=findobj(handles.sizeblobs,'markersize',format.unfitmarkersize);
set(hhh,'markerfacecolor',oncolor);

%cdata=ravemakecdata(handles.fig,[],handles.cmapnames{udata.format.mcmap});

unfitmarkercolor=uicontrol('position',[origin(1)+115 origin(2)+227 22 22],...
    'style','pushbutton','string','','backgroundcolor',format.markerunfitcolor,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@mcolor_callback,'tag','unfitmarkercolor');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


histtext=uicontrol('position',[origin(1)+25 origin(2)+200 180 20],...
    'style','text','string','Histograms','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

if udata.format.nbars>20
    value=(udata.format.nbars-20)/2+20;
else
    value=udata.format.nbars;
end

nbarstext=uicontrol('position',[origin(1)+35 origin(2)+180 150 20],...
    'style','text','string','Number of Bars:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
nbars=uicontrol('position',[77+3.6*value origin(2)+135 50 20],...
    'style','text','string',sprintf('%3.0f',udata.format.nbars),'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',12,'horizontalalignment','left','fontweight','bold');


%scale slider:
[jslider1 hslider1]=javacomponent('javax.swing.JSlider',[origin(1)+40 origin(2)+155 190 30]);
jslider1.setPaintTicks(1)

jslider1.setSnapToTicks(0)
jslider1.setMinimum(2)
jslider1.setMaximum(50)
jslider1.setMajorTickSpacing(2);
%jslider.setMinorTickSpacing(1);
jslider1.setValue(value);
set(jslider1,'background',java.awt.Color.white)
set(jslider1,'StateChangedCallback',{@nbars_Callback,nbars});



value=udata.format.barwidth/5*100;

barwidthtext=uicontrol('position',[origin(1)+35 origin(2)+110 150 20],...
    'style','text','string','Bar Width:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
barwidth=uicontrol('position',[69+9.2*value origin(2)+65 50 20],...
    'style','text','string',[sprintf('%3.0f',value*5),'%'],'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',12,'horizontalalignment','left','fontweight','bold');

%scale slider:
[jslider2 hslider2]=javacomponent('javax.swing.JSlider',[origin(1)+40 origin(2)+85 190 30]);
jslider2.setPaintTicks(1)

jslider2.setSnapToTicks(0)
jslider2.setMinimum(1)
jslider2.setMaximum(20)
jslider2.setMajorTickSpacing(1);
%jslider.setMinorTickSpacing(1);
jslider2.setValue(value);
set(jslider2,'background',java.awt.Color.white)
set(jslider2,'StateChangedCallback',{@barwidth_Callback,barwidth});

handles.javacomps={jslider1;jslider2};

barfillcolortext=uicontrol('position',[origin(1)+35 origin(2)+40 180 20],...
    'style','text','string','Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

barfillcolor=uicontrol('position',[origin(1)+90 origin(2)+42 22 22],...
    'style','pushbutton','string','','backgroundcolor',format.facecolor,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@barcolor_callback);

edgecheck=uicontrol('style','checkbox','position',[origin(1)+140 origin(2)+42 100 22],...
    'string','Draw edges','value',format.drawedge,'tag','edgecheck','callback',@edgecheck_callback,...
    'backgroundcolor',handles.colors.tabbg);

percentcheck=uicontrol('style','checkbox','position',[origin(1)+35 origin(2)+10 200 22],...
    'string','Display error as a percentage','value',format.percenterror,'tag','percentcheck','callback',@percentcheck_callback,...
    'backgroundcolor',handles.colors.tabbg);



%% group items and finish up
handles.tabobjects=[graphtext axestext dataseriestext bgtext gridtext ...
    bgwhite bglight bgdark bgblack nogrid magrid migrid fitmarkerstyletext fitmarkersizetext fitmarkercolortext ... 
    fitmarkerstyleaxes fitmarkersizeaxes fitmarkercolor titletext titlebox fittext ...
    unfitmarkerstyletext unfitmarkersizetext unfitmarkercolortext ...
    unfitmarkerstyleaxes unfitmarkersizeaxes unfitmarkercolor unfittext histtext ...
    barwidthtext nbarstext barfillcolortext hslider1 hslider2 nbars barwidth barfillcolor edgecheck percentcheck];

handles.activetab='format';

set(handles.infobar,'string','');

guidata(src,handles);

%% HERE BE CALLBACKS
%
%
%
%
%
%
%
%
%% 
function bgblob_callback(src,ev)
handles=guidata(src);

uicontrol(handles.dummyobj)

colors=get(src,'userdata');
gridcolor=colors(1,:);
textcolor=colors(2,:);

plotcolor=get(src,'backgroundcolor');

%find text labels to recolor: (text type objects onthe diagonal.)
%try
%texts=findobj(handles.subax{handles.activeindex},'tag','axeslabel');
% catch
%    texts=[]; %for rectangular. 
% end

%update fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.bg=colors(3,1);
set(handles.fakeax(handles.activeindex),'userdata',udata);

%unpop blobs:
set(handles.bgblobs,'value',0);
set(src,'value',1)

%change colors
set(handles.subfakerax{handles.activeindex},'color',plotcolor,'xcolor',gridcolor,'ycolor',gridcolor)
set(handles.subfakeax{handles.activeindex},'xcolor',gridcolor,'ycolor',gridcolor);
%set(texts,'color',textcolor,'backgroundcolor',plotcolor)


%fix tick marks
if all(plotcolor==[0 0 0])
    set(handles.subax{handles.activeindex},'ticklength',[0 0])
else
    set(handles.subax{handles.activeindex},'tickdir','in','ticklength',[.01 .025])
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function magrid_callback(src, eventdata)
handles=guidata(src);
%inputs=get(handles.fakerax{handles.activeindex},'userdata');

set(handles.gridchecks,'value',0)
set(src,'value',1)

%updata fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.grid=2;
set(handles.fakeax(handles.activeindex),'userdata',udata);

set(handles.subfakerax{handles.activeindex},'XGrid','on','YGrid','on')
set(handles.subfakerax{handles.activeindex},'XminorGrid','off','YminorGrid','off')
set(handles.subfakeax{handles.activeindex},'XGrid','off','YGrid','off')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function migrid_callback(src, eventdata)
handles=guidata(src);

set(handles.gridchecks,'value',0)
set(src,'value',1)


%updata fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.grid=3;
set(handles.fakeax(handles.activeindex),'userdata',udata);

set(handles.subfakerax{handles.activeindex},'XminorGrid','on','YminorGrid','on')
set(handles.subfakerax{handles.activeindex},'XGrid','off','YGrid','off')
set(handles.subfakeax{handles.activeindex},'XGrid','on','YGrid','on')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function nogrid_callback(src, eventdata)
handles=guidata(src);

set(handles.gridchecks,'value',0)
set(src,'value',1)

%updata fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.grid=1;
set(handles.fakeax(handles.activeindex),'userdata',udata);


set(handles.subfakerax{handles.activeindex},'XminorGrid','off','YminorGrid','off')
set(handles.subfakerax{handles.activeindex},'XGrid','off','YGrid','off')
set(handles.subfakeax{handles.activeindex},'XGrid','off','YGrid','off')



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function title_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

if udata.view.graphs==5
titel=findobj(handles.activegraph,'tag','title');
else
    titel=get(handles.subax{handles.activeindex}(1),'title');
end


set(titel,'string',get(src,'string'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function styleblob_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

newstyle=get(src,'marker');

switch get(get(src,'parent'),'tag')
    case 'fitstyleaxes'
        udata.format.fitmarker=newstyle;
        sizeax=findobj(handles.tabobjects,'tag','fitsizeaxes');
        set(get(sizeax,'children'),'marker',newstyle)
        set(get(get(src,'parent'),'children'),'markerfacecolor',[.9 .9 .9])
        set(src,'markerfacecolor',handles.colors.text)
        
    case 'unfitstyleaxes'
        udata.format.unfitmarker=newstyle;
        sizeax=findobj(handles.tabobjects,'tag','unfitsizeaxes');
        set(get(sizeax,'children'),'marker',newstyle)
        set(get(get(src,'parent'),'children'),'markerfacecolor',[.9 .9 .9])
        set(src,'markerfacecolor',handles.colors.text)
end
    
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreategoodness(handles.fig,[]);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function sizeblob_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

newsize=get(src,'markersize');

switch get(get(src,'parent'),'tag')
    case 'fitsizeaxes'
        udata.format.fitmarkersize=newsize;
        %sizeax=findobj(handles.tabobjects,'tag','fitsizeaxes');
        %set(get(sizeax,'children'),'marker',newstyle)
        set(get(get(src,'parent'),'children'),'markerfacecolor',[.9 .9 .9])
        set(src,'markerfacecolor',handles.colors.text)
        
    case 'unfitsizeaxes'
        udata.format.unfitmarkersize=newsize;
%         sizeax=findobj(handles.tabobjects,'tag','unfitsizeaxes');
%         set(get(sizeax,'children'),'marker',newstyle)
        set(get(get(src,'parent'),'children'),'markerfacecolor',[.9 .9 .9])
        set(src,'markerfacecolor',handles.colors.text)
end
    
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreategoodness(handles.fig,[]);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function mcolor_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.facecolor,'Choose a bar fill color');
set(src,'backgroundcolor',newcolor);

switch get(src,'tag')
    case 'fitmarkercolor'
        udata.format.markerfitcolor=newcolor;
       
    case 'unfitmarkercolor'
         udata.format.markerunfitcolor=newcolor;
    
end

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreategoodness(handles.fig,[]);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function nbars_Callback(src,ev,hObject) %#ok<INUSL>
%hObject = nbars 
numbars=src.getValue;
if numbars>20;numbars=20+(numbars-20)*2;end
pos=get(hObject,'position');
set(hObject,'string',sprintf('%3.0f',numbars),'position',[49+58+3.6*src.getValue pos(2:4)]);

if src.getValueIsAdjusting;return;end

handles=guidata(hObject);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.nbars=numbars;
set(handles.fakeax(handles.activeindex),'userdata',udata)
guidata(hObject,handles);

ravecreategoodness(handles.fig,[]);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function barwidth_Callback(src,ev,hObject) %#ok<INUSL>

barwidth=src.getValue*5;

pos=get(hObject,'position');
set(hObject,'string',[sprintf('%3.0f',barwidth),'%'],'position',[49+50+9.2*src.getValue pos(2:4)]);


if src.getValueIsAdjusting;return;end

handles=guidata(hObject);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.barwidth=barwidth/100;
set(handles.fakeax(handles.activeindex),'userdata',udata)
guidata(hObject,handles);

ravecreategoodness(handles.fig,[]);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function barcolor_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.facecolor,'Choose a bar fill color');
set(src,'backgroundcolor',newcolor);
udata.format.facecolor=newcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%update histogram:
ravecreategoodness(handles.fig,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edgecheck_callback(src,ev)
handles=guidata(src);

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.drawedge=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
%update histogram:
ravecreategoodness(handles.fig,[]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function percentcheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.percenterror=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreategoodness(handles.fig,[]);


