function raveTableHeaderCallback(jsrc,jev,src) %#ok<INUSL>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

%do nothing if user was dragging this column.
if handles.maintable.wasdragged
    handles.maintable.wasdragged=0;
    guidata(src,handles);
    return
end

MouseEvent=jev;

if MouseEvent.getClickCount == 2 %double click
    %if this is a function, display it in the editor:
    handles=guidata(src);
    x=MouseEvent.getX();
    columnModel=handles.maintable.jtable.getColumnModel();
    c=columnModel.getColumnIndexAtX(x); %View Index
    thiscol=handles.maintable.jtable.convertColumnIndexToModel(c); %model index
    thiscol=thiscol+1; %convert to matlab index;
    if handles.isfunction{handles.maintable.d}(thiscol)
        edit(handles.funnames{handles.maintable.d}{thiscol});
    end
    
     
elseif MouseEvent.getButton > 1    %right click
    %this will eventually display a context menu
    
     handles=guidata(src);

    %determine where to put context menu:
    
    xpos1=get(handles.maintable.handle,'position');
    xpos2=MouseEvent.getX;
    xpos3=handles.maintable.jtable.getVisibleRect().getX();
    
    ypos1=get(handles.maintable.handle,'position');
    ypos2=handles.maintable.jtable.getVisibleRect().getY();
    ypos3=MouseEvent.getY;
    ypos4=handles.maintable.jtable.getTableHeader.getHeight();
    
    
    rowHeader=handles.maintable.jscroll.getComponent(4);
    rhw=rowHeader.getWidth;
    
   finalpos=[xpos1(1)+xpos2(1)-xpos3+rhw ypos1(2)+ypos1(4)-ypos3]; %50 is width of row header. fix this to calculate row header width.
   
   set(handles.contextmenus.maintablecolumnheader,'position',finalpos,'visible','on');
   set(0,'userdata',MouseEvent);

    
else %presumably single left click 
   %select this column
   handles=guidata(src);
   d=handles.maintable.d;
   jtable=handles.maintable.jtable;
    
   x=MouseEvent.getX();
   columnModel=handles.maintable.jtable.getColumnModel();
   c=columnModel.getColumnIndexAtX(x); %View Index
   %thiscol=handles.maintable.jtable.convertColumnIndexToModel(c); %model index
    thiscol=c;
   
   nrows=handles.maintable.models{d}.getRowCount();
   
   mods=MouseEvent.getModifiers(); %binary weirdness.
   mods=fliplr(dec2bin(mods,64)); %no reason not to use 64 bits...
   mods=uint8(mods)-48;
      
   %NOBUTTON=0;
   %BUTTON1_MASK=16;
   %SHIFT_MASK=1;
   %CTRL_MASK=2;
   %ALT_MASK=8;
   %META_MASK=4;
   %BUTTON2_MASK=8;
   %BUTTON3_MASK=4;
   
   selectedCols=jtable.getSelectedColumns;
   selectedRows=jtable.getSelectedRows;
   
   
   if mods(2) %CTRL
       %if non-columns are selected, clear selection.
       if numel(selectedRows)<nrows
           jtable.clearSelection();
       end
       
       %add this column to selection:
       
      if ~ismember(thiscol,selectedCols)
           jtable.addColumnSelectionInterval(thiscol,thiscol);
           jtable.setRowSelectionInterval(0,nrows-1);
       else
           jtable.removeColumnSelectionInterval(thiscol,thiscol);
           jtable.setRowSelectionInterval(0,nrows-1);
       end
       
       
       
       
       
   elseif mods(1) %SHIFT
       %if non-columns are selected, clear selection.
       if numel(selectedRows)<nrows
           jtable.clearSelection();
       end
       
       if thiscol<min(selectedCols)
           jtable.addColumnSelectionInterval(thiscol,min(selectedCols-1));
       elseif thiscol>max(selectedCols)
           jtable.addColumnSelectionInterval(max(selectedCols+1),thiscol);
       end
       
       jtable.setRowSelectionInterval(0,nrows-1)
       
       
       
   else %presumably no modifires
       
   jtable.setColumnSelectionInterval(thiscol,thiscol);
   jtable.setRowSelectionInterval(0,nrows-1);
   
    
       
       
   end
   
   

    
end