function ravecreatemaintable(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

%table dims:
left=30+315*handles.prefs.tabscale;
bottom=1;
height=handles.height-35;
width=handles.width-(30+315*handles.prefs.tabscale);

%new method:
mtable=uitable('parent',handles.fig,'units','pixels','position',[left bottom width height]);
jscroll=findjobj(mtable);
h=jscroll.getComponents;
viewport=h(1);
a=viewport.getComponents;
jtable=a(1); %com.mathworks.hg.peer.ui.UITablePeer 
jtable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF); %no auto resize (show horizontal scroll)
g=handles.colors.maintable.grid;
jtable.setGridColor(java.awt.Color(g(1),g(2),g(3)));
jtable.setBackground(java.awt.Color(1,1,1));
jtable.setNonContiguousCellSelection(false); %need to do this to allow setting cell selection
jtable.setColumnSelectionAllowed(true);
jtable.setRowSelectionAllowed(true);

%save header renderer for future use:
rowHeaderViewport=jscroll.getComponent(4);
rowHeader=rowHeaderViewport.getComponent(0);
cm=rowHeader.getColumnModel;
c=cm.getColumn(0);
handles.maintable.defaultRowHeaderRenderer=c.getCellRenderer;

%fix blinking:
set(jtable,'DoubleBuffered','on'); 
set(jscroll,'DoubleBuffered',1);

set(mtable,'backgroundcolor',[1 1 1]);
handles.maintable.handle=mtable;
handles.maintable.jtable=jtable;
handles.maintable.jscroll=jscroll;
% handles.maintable.d=0;
% handles.maintable.a=0;
guidata(handles.fig,handles);


