function ravedisplaymaintable(src,ev)
%shows the current tablemodel in the main table.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
d=handles.maintable.d;
a=handles.maintable.a;

if d==0;return;end;

jtable=handles.maintable.jtable;
%tablemodel=jtable.getModel; %mtable uses defaulttablemodel

sorter=handles.maintable.models{d};
jtable.setModel(handles.maintable.models{d});
sorter.setTableHeader(jtable.getTableHeader());


%set callback for table:
jtSrc = handle(jtable,'callbackproperties');
set(jtSrc,'MouseReleasedCallback',{@raveTableMouseReleaseCallback,handles.fig})

%set callback for column headers:
jhead=jtable.getTableHeader();
jhead.setReorderingAllowed(1); %allow column reordering %NOTE: this might break some things in RaveTableSorter that assume no reordering. 
chSrc = handle(jhead,'callbackproperties');
set(chSrc,'MouseReleasedCallback',{@raveTableHeaderCallback,handles.fig})
set(chSrc,'MouseDraggedCallback',{@raveTableHeaderDraggedCallback,handles.fig})

%store the class "object" in a variable
obj=java.lang.Object;
class=obj.getClass();

%set up row headers:
rowHeaderViewport=handles.maintable.jscroll.getComponent(4);
rowHeader=rowHeaderViewport.getComponent(0);
%renderer:
rrrr=RaveDefaultRowHeaderRenderer();

tm=rowHeader.getColumnModel();
tc=tm.getColumn(0);


if handles.maintable.colorrows
%rowHeader.setDefaultRenderer(class,rrrr);
tc.setCellRenderer(rrrr);
else
 tc.setCellRenderer(handles.maintable.defaultRowHeaderRenderer);   
end

%callbacks:
rhSrc = handle(rowHeader,'callbackproperties');
set(rhSrc,'MouseReleasedCallback',{@raveRowHeaderCallback,handles.fig})

%set default renderer for object columns:
rrr=RaveDefaultTableCellRenderer();
jtable.setDefaultRenderer(class,rrr);

%select rows that are selected in this analysis:
selectedRows=find(handles.isselected{d}{a}); %#ok<EFIND>

if ~isempty(selectedRows)
    selectedRows=selectedRows-1;
    ncols=handles.maintable.models{d}.getColumnCount();
  
    
    jtable.setColumnSelectionInterval(0,ncols-1);
    jtable.setRowSelectionInterval(selectedRows(1),selectedRows(1));
    for i=2:numel(selectedRows)
       jtable.addRowSelectionInterval(selectedRows(i),selectedRows(i));    
    end

end





