function ravemaintableundo(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

if isempty(handles.maintable.undos{1})
    return %nothing to undo
end

evt=handles.maintable.undos{1};

if evt.d ~= handles.maintable.d
    set(handles.infobar,'string',['Next "Undo" refers to dataset ' handles.datasetnames{evt.d} ' View it in table to undo.'])
    beep
    return
end

d=evt.d;

row=evt.row;
col=evt.col;

restorevalues=evt.oldvalue;

%turn off tablechanged callback to avoid a loop:
set(handles.maintable.models{d},'TableChangedCallback',[]);

for r=1:numel(row)
    for c=1:numel(col)
        handles.maintable.jtable.setValueAt(restorevalues{r,c},row(r),col(c));
        
        if ~isnan(str2double(restorevalues{r,c}))
            handles.alldata{d}(r+1,c+1)=str2double(restorevalues{r,c});
        end
        
        
    end
end

%store event:
handles.maintable.redos(2:50)=handles.maintable.redos(1:49);
handles.maintable.redos{1}=evt;

handles.maintable.undos(1:49)=handles.maintable.undos(2:50);
handles.maintable.undos{50} = [];

%turn table callback back on:
set(handles.maintable.models{d},'TableChangedCallback',{@ravemaintablechangedcallback,handles.fig});

%check if legal undos remain:
if isempty(handles.maintable.undos{1})
    set(src,'enable','off')
end
set(findobj(handles.fig,'tag','redobutton'),'enable','on');

%update data set:
guidata(handles.fig,handles);