function model=raveupdatemaintablemodel(src,ev,d,a)
%updates the RaveTableModel of dataset d using analysis a.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

if isfield(handles,'indata');
    handles=handles.indata;
end

if d>0;
    data=handles.alldata{d};
    varnames=handles.allnames{d};
    rownums=1:size(data,1);
    datatypes=handles.datatype{d};
    isfunction=handles.isfunction{d};
else
    data=[];
    varnames=[];
    rownums=[];
    datatypes=[];
    isfunction=false;
end

%convert to cells:
data=num2cell(data);

%to do: substitute in strings for string columns.

dblArray=javaArray('java.lang.Object',size(data,1),size(data,2));
for c=1:size(data,2)
    for r=1:size(data,1);
        %to do: make this use the correct java type depending on datatypes
        %values.        
        dblArray(r,c)=java.lang.String(num2str(data{r,c}));
    end
end


colArray=javaArray('java.lang.String',size(data,2));
for c=1:size(data,2)
    colArray(c)=java.lang.String(varnames{c});
end

isFunction=javaArray('java.lang.Boolean',numel(colArray));
for c=1:numel(colArray)
    isFunction(c)=java.lang.Boolean(isfunction(c));
end



model=RaveTableModel(dblArray,varnames,isFunction);








