function distance=crowding_distance_assignment(I,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
M=size(I,2); %number of obj functions
l=size(I,1); %number of points on this frontier
distance=zeros(l,1);


I=double(I); %for gpgpu

for m=1:M

    objrange=max(I(:,m))-min(I(:,m));
    if objrange==0 %all points have a common value for this objective
        continue %go to next objective (crowding distance = 0 for this obj) (prevents dividing by zero later)
    end

    [Isorted,index]=sortrows(I,m); %sort in ascending order according to this objective (descending would be fine too)
    distance(index(1))=inf;
    distance(index(end))=inf; %... so that end points are always selected first.

    for i=2:l-1
        distance(index(i))=distance(index(i))+(I(index(i+1),m)-I(index(i-1),m))/objrange; %dividing by objrange prevents biasing according to o'mag of objectives.
    end
end