function ravechangetab(src,eventdata)
%this function executes first whenever you click any tab, and mostly serves
%to undo things that should be undone when you click *away* from the
%previous tab.
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

handles=guidata(src);

lasttab=handles.activetab;
%newtab=lower(get(gco,'string'));

%handles.activetab=get(src,'string')

%unhighlight currently selected subgraph for a scatterplotmatrix:
if ishandle(handles.activesubgraph)
    %   if ~strcmp(newtab,'format'); %need double statement structure here... trust me.
    set(handles.activesubgraph,'xcolor',[0 0 0],'ycolor',[0 0 0]);
    %  end
end

%undo any graph placement callbacks:
set(handles.mainaxes,'buttondownfcn',@ravedragview)
set(handles.explorer,'buttondownfcn',@ravemoveview)

%undo any graph interaction buttondownfcns:

% 
% if strcmp(handles.activetype,'contour')
%     set(handles.activegraph,'buttondownfcn',@raveupdatecontour)  
% else   
%     set(handles.activegraph,'buttondownfcn','')
% end


%turn off the print region of interest:
set(handles.roi,'visible','off');


%if this tab contains a flexgrid, delete it:
if iscom(handles.tabflexgrid)
    delete(handles.tabflexgrid)
    handles.tabflexgrid=[];
end

%disable 3d rotation:
if isa(handles.rotater,'graphics.rotate3d')
    set(handles.rotater,'enable','off')
end

%if has subgraphs, replace subgraph select function in case it got overwritten
% if strcmp(handles.activetype,'scattermatrix')
%     try
%         set(handles.subax{handles.activeindex},'hittest','on','buttondownfcn',@raveselectsubgraph)
%     end
% end

%delete temporary handles:
handles.temp=[];

%delete old tabobjects:

%delete(handles.tabobjects)

delete(handles.tabobjects(ishandle(handles.tabobjects)));
drawnow;

handles.tabobjects=[];
guidata(src,handles);

%find objects that got left behind:
junks=findobj(handles.fig,'type','uicontrol');
posses=cell2mat(get(junks,'pos'));
origin=get(handles.tabaxes,'position');
trash=posses(:,1)>origin(1) & posses(:,1)<origin(1)+origin(3) & posses(:,2)>origin(2) & posses(:,2)<origin(2)+origin(4);
delete(junks(trash));

junktxt=findobj(handles.tabaxes,'type','text');
delete(junktxt);
