function varargout = ravedefinetargetsgui(varargin)
% RAVEDEFINETARGETSGUI M-file for ravedefinetargetsgui.fig
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @ravedefinetargetsgui_OpeningFcn, ...
    'gui_OutputFcn',  @ravedefinetargetsgui_OutputFcn, ...
    'gui_LayoutFcn',  @ravedefinetargetsgui_LayoutFcn , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT



function h=ravedefinetargetsgui_LayoutFcn(varargin)
h=openfig('ravedefinetargetsgui.fig');

% --- Executes just before ravedefinetargetsgui is made visible.
function ravedefinetargetsgui_OpeningFcn(hObject, eventdata, handles, varargin)

src=varargin{1};
fig=ancestor(src,'figure');
thispos=get(hObject,'position');
screensize=get(fig,'position');
set(hObject,'units','pixels','position',[screensize(1)+screensize(3)/2-thispos(3)/2 screensize(2)+screensize(4)/2-thispos(4)/2 thispos(3) thispos(4)])


load raveprefs

set(hObject,'color',raveprefs.colors.frame)

alltext=findobj(hObject,'style','text');
set(alltext,'backgroundcolor',raveprefs.colors.frame);

set(handles.axes1,'color','none','xcolor',raveprefs.colors.frame,...
    'ycolor',raveprefs.colors.frame,'zcolor',raveprefs.colors.frame);

%make title
text(0,.75,'Define Target Values','parent',handles.axes1,'fontname',raveprefs.fonts.title,'fontsize',20*raveprefs.fonts.titlescale,'color',raveprefs.colors.title)

%get data from calling figure:
callershandles=guidata(gcbo); %gcbo = button in either managedatagui or handles.fig

if isfield(callershandles,'indata') %this window was called from managedatagui
    
    handles.indata=guidata(gcbo);
    d=get(handles.datasetlist,'value');
    
else %this window was called directly from main rave figure
    
    handles.indata.indata=guidata(gcbo); %need an extra "indata" layer since managedatagui doesnt exist.
    
    analysismenu=findobj(handles.indata.indata.tabobjects,'tag','analysismenu');
    datasetmenu=findobj(handles.indata.indata.tabobjects,'tag','datasetmenu');
    d=get(datasetmenu,'value');
    a=get(analysismenu,'value');
    
    set(handles.datasetlist,'string',handles.indata.indata.datasetnames,'value',d,'visible','off');
      
end

handles.lastd=1; %last selected data set menu value.

names=handles.indata.indata.allnames{d};%(logical(handles.indata.indata.isresponse{d}));
handles.names=names; %make accessible to the done button
targets=num2cell(handles.indata.indata.targetvalues{d});%(logical(handles.indata.indata.isresponse{d}));

warnstate=warning('query','MATLAB:uitable:OldTableUsage');
warning('off','MATLAB:uitable:OldTableUsage');
[table, buttons] = createTable (hObject,{'Variable Name','     Value      '}, [names' targets'], false,...
    'Units','pixels','Position',[20 30 328 300]);
handles.table=table;
warning(warnstate.state,'MATLAB:uitable:OldTableUsage');

% Choose default command line output for ravedefinetargetsgui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

set(hObject,'closerequestfcn',{@donebutton_Callback,handles});


% --- Outputs from this function are returned to the command line.
function varargout = ravedefinetargetsgui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function donebutton_Callback(hObject, eventdata, handles)

data = cell(handles.table.getData);

targets=data(:,2);
for r=1:1:numel(targets)
    if ischar(targets{r})
        targets{r}=eval(targets{r});
    end
end

targets=cell2mat(targets);
targets=targets';
if any(isnan(targets))
    errordlg('All values must be numeric.','You can''t do that.');
else   
    set(0,'userdata',targets);
    delete(gcf)
end

% --- Executes on selection change in datasetlist.
function datasetlist_Callback(hObject, eventdata, handles)
%apply current table values to selected data set. 


% --- Executes during object creation, after setting all properties.
function datasetlist_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% 
% % --- Executes during object deletion, before destroying properties.
function datasetlist_DeleteFcn(hObject, eventdata, handles)



