function ravedisplayworkspace(src,ev)
%this function saves all changes made in the table to the correct
%dataset/analysis. It is run when (before) switching to workspace view.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

%send table selection to workspace:
selectedrows=handles.maintable.jtable.getSelectedRows();
selectedrows=selectedrows+1;

try %#ok<TRYNC> %gives error if no data set loaded.
    handles.isselected{handles.maintable.d}{handles.maintable.a}(:)=false;
    handles.isselected{handles.maintable.d}{handles.maintable.a}(selectedrows)=true;
end
    guidata(src,handles);



%update data set if needed:
for d=1:numel(handles.datasetnames)
   updates=handles.datasetupdatespending{d};
   %IMPORTANT: this does not actually check the update type since at the 
   %moment the only updates you can make from the table are equivalent 
   %to updating the rows. might need to fix this in the future. 
   if ~isempty(updates)
       raveupdatedataset(handles.fig,[],'replaceall',d);
   end
   
   handles.datasetupdatespending{d}=cell(0);
   
   %then update analyses:
   for a=1:numel(handles.analysisnames)
       
      %always update selection. not gonna bother to check if it's changed. 
      % if ismember('isselected',handles.analysisupdatespending{d}{a})
           raveupdateanalysis(handles.fig,[],'isselected',1,d,a)
      % end

       if ismember('visiblerows',handles.analysisupdatespending{d}{a})
           raveupdateanalysis(handles.fig,[],'visiblerows',1,d,a)
       end
       
       if ismember('rowcolors',handles.analysisupdatespending{d}{a})
           raveupdateanalysis(handles.fig,[],'rowcolors',1,d,a)
       end
   end
end


guidata(handles.fig,handles);



