function g=raveevaluateconstraint(src,thisconstraint,indata,ignore)
%evaluates the regression with index stored in thisconstraint using the data stored in data.
%thisconstraint is an index into:
%handles.constrainthandles{udata.view.dataset}{udata.view.analysis}{thisconstraint}
%ignore is a logical vector of length=size(indata,2) (numvars) where 1 means do not evaluate this
%regression (if that varaible isfunction). use this to do things like sweeps through regressed
%variables. or just make ignore==0, to  evaluate all constraints.
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

% determine which variables appear in this constraint:

% thisstring=char(handles.constrainthandles{udata.view.dataset}{udata.view.analysis}{thisconstraint});
% thisstring=thisstring(8:end);

varnumbers=handles.constraintvars{udata.view.dataset}{udata.view.analysis}{thisconstraint};

varnumbers=setdiff(varnumbers,find(ignore)); %dont evaluate regressions of ignored vars

if ~isempty(varnumbers)
%evaluate all regressions necessary for this constraint:
respdata=raveevaluateregression(handles.fig,udata.view.dataset,varnumbers,indata);
indata(:,varnumbers)=respdata;
end

%solve evaluate this constraint for y variable:

thishandle=handles.constrainthandles{udata.view.dataset}{udata.view.analysis}{thisconstraint};
g=thishandle(indata);

