function varargout = ravem2mgui(varargin)
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


% Last Modified by GUIDE v2.5 16-Oct-2008 15:45:32

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @ravem2mgui_OpeningFcn, ...
    'gui_OutputFcn',  @ravem2mgui_OutputFcn, ...
    'gui_LayoutFcn',  @ravem2mgui_LayoutFcn, ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

function h=ravem2mgui_LayoutFcn(varargin)
h=openfig('ravem2mgui.fig');

% --- Executes just before ravem2mgui is made visible.
function ravem2mgui_OpeningFcn(hObject, eventdata, handles, varargin)
%set theme:
load raveprefs
handles.indata=get(0,'userdata');
set(0,'userdata',[]);
indata.cancelled=1;
set(0,'userdata',indata);

src=varargin{1};
fig=ancestor(src,'figure');
thispos=get(hObject,'position');
screensize=get(fig,'position');
set(hObject,'units','pixels','position',[screensize(1)+screensize(3)/2-thispos(3)/2 screensize(2)+screensize(4)/2-thispos(4)/2 thispos(3) thispos(4)])

%display button icons
A=imread('browse.bmp');
set(handles.browsebutton,'cdata',A)

set(hObject,'color',raveprefs.colors.frame);
set(handles.uipanel1,'backgroundcolor',raveprefs.colors.tabbg);
set(handles.uipanel2,'backgroundcolor',raveprefs.colors.tabbg);


set(handles.titleaxes,'color','none','xcolor',raveprefs.colors.frame,...
    'ycolor',raveprefs.colors.frame,'zcolor',raveprefs.colors.frame);
set([handles.titleaxes handles.topframeaxes handles.bottomframeaxes],'visible','off');

set(handles.listbox3,'string','You must browse for a file first.');

set(hObject,'units','pixels');

% %make title:
text(0,.4,'Import m-File','parent',handles.titleaxes,'fontname',raveprefs.fonts.title,'fontsize',20*raveprefs.fonts.titlescale,...
   'color',raveprefs.colors.title,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Select Variables to Model','parent',handles.axes5,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
   'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Select Input Variables','parent',handles.topframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
   'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');

text(0,.4,'Configure','parent',handles.bottomframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
   'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');

set(handles.axes5,'visible','off')

set(handles.varlist,'string',handles.indata.allnames{1},'value',find(~handles.indata.isresponse{1}));



%get exising handles structure from maingui
handles.indata=guidata(gcbo); %gcbo = "manage data sets" button in maingui

set(handles.analysismenu,'string','Default');
set(handles.datasetmenu,'string',handles.indata.datasetnames)


% Choose default command line output for ravem2mgui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = ravem2mgui_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;


%%  --- Executes on button press in importbutton.
function importbutton_Callback(hObject, eventdata, handles)
set(hObject,'enable','off');
drawnow;
indata.cancelled=0;
indata.dataset=get(handles.datasetmenu,'value');
indata.analysis=get(handles.analysismenu,'value');
indata.responsename=get(handles.listbox3,'string');
indata.path=get(handles.sourcename,'string');
indata.varnames=handles.indata.allnames{get(handles.datasetmenu,'value')}(get(handles.varlist,'value'));
indata.nargout=get(handles.listbox3,'value');



set(0,'userdata',indata);

close(gcf);



% --- Executes on button press in cancelbutton.
function cancelbutton_Callback(hObject, eventdata, handles)
indata.cancelled=1;
set(0,'userdata',indata);

close(gcf);


%% unused callbacks:
% --- Executes on selection change in analysismenu.
function analysismenu_Callback(hObject, eventdata, handles)
%doesnt do anything yet.

% --- Executes during object creation, after setting all properties.
function analysismenu_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in datasetmenu.
function datasetmenu_Callback(hObject, eventdata, handles)
%lets user select which data set they wanna use.
d=get(hObject,'value');

set(handles.varlist,'string',handles.indata.allnames{d},'value',find(~handles.indata.isresponse{d}));




% --- Executes during object creation, after setting all properties.
function datasetmenu_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on selection change in varlist.
function varlist_Callback(hObject, eventdata, handles)
% hObject    handle to varlist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns varlist contents as cell array
%        contents{get(hObject,'Value')} returns selected item from varlist


% --- Executes during object creation, after setting all properties.
function varlist_CreateFcn(hObject, eventdata, handles)
% hObject    handle to varlist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function sourcename_Callback(hObject, eventdata, handles)
% hObject    handle to sourcename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sourcename as text
%        str2double(get(hObject,'String')) returns contents of sourcename as a double


% --- Executes during object creation, after setting all properties.
function sourcename_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sourcename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in browsebutton.
function browsebutton_Callback(hObject, eventdata, handles)
% hObject    handle to browsebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[name,path,index]=uigetfile({'*.m','m File (*.m)'},'Choose function file to load:'); %#ok<NASGU>

%get output names for this function:

if ~ischar(name);return;end

fid=fopen(fullfile(path,name));

firstline=fgetl(fid);
firstline=strtrim(firstline);

%ignore comments at top of file
while firstline(1)==char(37) %this line is a comment
    firstline=fgetl(fid);
    firstline=firstline(~isspace(firstline));
end

if ~strcmpi(firstline(1:8),'function')
    warndlg('The file you selected appears to be a script, not a function. If it really is a function, the first line of the file must be the function declaration.','Not a Function')
    return
end

try
    if strcmp(firstline(10:17),'varargin') || strcmp(firstline(10:17),'varargin')
        warndlg('We like varargout as much as the next guy, but unfortunately RAVE requires each output to be listed explicitly on the first line of the m file.','You can''t do that')
        return
    end
catch
    warndlg('This function doesnt take any inputs. See the rave use manual for required input format for user-supplied functions in rave.','You can''t do that');
    return
end

%done with the file for now.
fclose(fid);


%GET OUTPUT VARIABLE NAMES

%ok, enough with the errors... check how many outputs this function has.
if firstline(10)==char(91) %[ %function probably has multiple outputs

    %find matching ] and extract variable names inbetween.
    lastindex=find(firstline==char(93));
    inputsection=firstline(9:lastindex);
    inputsection(inputsection==char(32) | inputsection==char(44) |inputsection==char(59))=char(59);
    inputsection=[inputsection(1:end-1),';]'];
    varnamez=symvar(inputsection);
    %put back in original order:
    for q=1:numel(varnamez)
       indecks(q)=strfind(inputsection,[varnamez{q},';']); %#ok<AGROW>
    end
    [crap,b]=sort(indecks);
    varnamez=varnamez(b);
    
    
else
    lastindex=find(firstline==char(61));
    varnamez={firstline(10:lastindex-1)};
    
end

%GET FILE NAME

if name==0
    %set(handles.sourcename,'string','');
    uicontrol(handles.sourcename)
else
    set(handles.sourcename,'string',[path name]);
    %set(handles.varnamebox,'string',name(1:end-2));
    set(handles.listbox3,'string',varnamez,'value',1:numel(varnamez));
    set(handles.importbutton,'enable','on');
    
end

handles.varnamez=varnamez;
guidata(hObject,handles);


% --- Executes on selection change in listbox3.
function listbox3_Callback(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox3


% --- Executes during object creation, after setting all properties.
function listbox3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


