function cdata=ravemakecdata(src,ev,name)
%makes cdata for use in coloring change-colormap buttons
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(src);
% creates CData matrix to display on colormap button:


%name is the name of the colormap to use. as in name='hsv';

%make colormap same size as width of uicontrol:
width=120;

switch lower(name)
    case 'hsvvv'
        %default rave colors:
        cmap=[1 0 .5;
            .5 0 1;
            0 .5 1;
            0 1 .5;
            .5 1 0;
            1 .5 0];
%     case 'jet'
%         cmap=jet(6);
%     case 'summer'
%         cmap=summer(6);
%     case 'autumn'
%         cmap=autumn(6);
%     case 'winter'
%         cmap=winter(6);
%     case 'spring'
%         cmap=spring(6);
%     case 'hot'
%         cmap=hot(6);
%     case 'cool'
%         cmap=cool(6);
%     case 'gray'
%         cmap=gray(6);
    otherwise
        index=find(strcmp(handles.cmapnames,name));
        
        wholecmap=get(handles.fig,'colormap');
        cmaprange=(index-1)*128+1:(index)*128;
        
        cmap=wholecmap(cmaprange([1 26 52 77 103 128]),:);
        
        
        
end


newcmap=ones(120,3);

for i=1:6
    newcmap(20*i-19:20*i,:)=repmat(cmap(i,:),[20,1]);
    %put a black line between colors
    newcmap(20*i,:)=[0 0 0];

end

cmap=newcmap;

height=20;

%make colormap into a 2d image, same height as uicontrol.
cdata=repmat(cmap,[1,1,height]);

%rearrange dimensions to be in correct 3D form:
cdata=permute(cdata,[3 1 2]);