function ravequitfunction(varargin)
%this is the closerequestfunction for rave. It runs when you try to close
%rave.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

try
handles=guidata(varargin{1});


set(0,'userdata','cancel');
origin=get(handles.fig,'position');

askbox=figure('units','pixels','position',[origin(1)+origin(3)/2-350/2 origin(2)+origin(4)/2-150/2 350 150],...
    'numbertitle','off','menubar','none','name','Close RAVE?','color',handles.colors.frame,...
    'resize','off','windowstyle','modal');


uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
    'position',[0 50 350 40],'string','Are you sure you want to quit RAVE?','horizontalalignment','center','fontsize',12)

uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
    'position',[00 125 350 20],'string',{'Please send comments, bugs, and suggestions to:'},'hor','center','fontsize',8)
uicontrol('style','pushbutton','units','pixels',...
    'position',[50 105 250 20],'string',{'mattdaskil@gatech.edu'},'hor','center','fontsize',8,...
    'foregroundcolor',[0 0 1],'callback',@mailmatt,'backgroundcolor',handles.colors.frame)

uicontrol('style','pushbutton','string','Quit','parent',askbox,'units','pixels',...
    'position',[110 10 100 30],'callback',@ravequitpopup_callback,'fontsize',10);
uicontrol('style','pushbutton','string','Cancel','parent',askbox,'units','pixels',...
    'position',[220 10 100 30],'callback',@ravequitpopup_callback,'fontsize',10);

uiwait(askbox)

answer=get(0,'userdata');

% cancel if they pick no or cancel
if ~strcmp(answer,'Quit')
    return
end

%if quitting:
%check for unsaved regressions, prompt to save or delete these.


pause(0.1) %need a pause or a drawnow or something or it'll crash when it tries to delete trayicon.

sysTray = java.awt.SystemTray.getSystemTray;
if (sysTray.isSupported)
   java.awt.SystemTray.getSystemTray.remove(handles.trayIcon);
end

%shut it down... shut it down.
shh= get(0,'showhiddenhandles');
set(0,'showhiddenhandles','on');
currFig=get(0,'currentfigure');
set(0,'showhiddenhandles',shh);
delete(currFig);
catch
    %shut it down... shut it down.
shh= get(0,'showhiddenhandles');
set(0,'showhiddenhandles','on');
currFig=get(0,'currentfigure');
set(0,'showhiddenhandles',shh);
delete(currFig);
end


function ravequitpopup_callback(src,ev) %#ok<INUSD>

set(0,'userdata',get(src,'string'));
close(gcbf);

function mailmatt(src,ev)
web(['mailto:mattdaskil@gatech.edu?subject=RAVE_ver',ravever])




