function raveresizetable(src,ev,targetindex) %#ok<INUSL>

%RAVE: resize all children of the uipanel to fit inside the panel. display scrollbars if necessary.
%reposition children of table uipanel to keep the upper-left corner in a
%constant postiion while resizing table. 
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

p=handles.fakerax(targetindex);

chax=findobj(p,'tag','colheader');
rhax=findobj(p,'tag','rowheader');
tax=handles.fakeax(targetindex);
dax=handles.allgraphs(targetindex);

if isempty(chax);chax=[];end;
if isempty(rhax);rhax=[];end;

oldpos=handles.temp.oldpos;
newpos=get(p,'position');

deltah=newpos(4)-oldpos(4);
deltaw=newpos(3)-oldpos(3);

kiddies=[chax rhax tax dax];

positions=get(kiddies,'position');

positions=cell2mat(positions);
positions=bsxfun(@plus,positions,[0 deltah 0 0]);
positions=mat2cell(positions,ones(size(positions,1),1),4);

set(kiddies,{'position'},positions);






