function raverotate3d(hObject,eventdata)

% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(hObject);

warning('off','MATLAB:uitools:uimode:callbackerror')

%do 3d rotation for active rave graph.

if get(hObject,'value')

    %start rotate3d mode:

    set(handles.infobar,'string','Note: You may not switch tabs or use navigator while in rotation mode.')

    handles.rotater=rotate3d(handles.activegraph');
    set(handles.rotater,'enable','on');

    %ban all axes from rotating:
    allaxes=findobj(handles.fig,'type','axes');

    setAllowAxesRotate(handles.rotater,allaxes,false);

    %allow active graph to rotate:
    setAllowAxesRotate(handles.rotater,handles.activegraph,true);


    %make functions to show/hide fake and faker axes during rotation:
    set(handles.rotater,'actionprecallback',@raverotate3dhide);
    set(handles.rotater,'actionpostcallback',@raverotate3dshow);

else
    %turn off 3d rotation:
    if isa(handles.rotater,'graphics.rotate3d')
        set(handles.rotater,'enable','off')
    end

    set(handles.infobar,'string','')

end

guidata(hObject,handles);

function raverotate3dhide(hObject,eventdata)
handles=guidata(hObject);
udata=get(handles.fakeax(handles.activeindex),'userdata');

set(handles.fakeax(handles.activeindex),'visible','off')
set(handles.fakerax(handles.activeindex),'visible','off')

if udata.view.hiderotate
   handles.temp.isvis=get(get(handles.activegraph,'children'),'visible');   
   set(get(handles.activegraph,'children'),'visible','off');    
end

guidata(hObject,handles);

function raverotate3dshow(hObject,eventdata)
handles=guidata(hObject);
udata=get(handles.fakeax(handles.activeindex),'userdata');



ravesynchaxes; %NOTE THIS IS A SCRIPT, NOT A FUNCTION

%turn them back on:
set(handles.fakeax(handles.activeindex),'visible','on')
set(handles.fakerax(handles.activeindex),'visible','on')


if udata.view.hiderotate
   set(get(handles.activegraph,'children'),{'visible'},handles.temp.isvis);    
end


%update userdata to reflect new rotation:
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.campos=get(handles.fakeax,'cameraposition');
udata.view.camtarg=get(handles.fakeax,'cameratarget');
set(handles.fakeax(handles.activeindex),'userdata',udata);


