function raveselectsubgraph(src,ev)
% this function activates when the user clicks a subgraph in a scatterplot matrix to make it
% the current graph. this function highlights the big graph, sets it as the
% current plotting target, and also sets the sub graph you clicked on as the
% current subgraph. this is used to change axes limits and labels, but
% otherwise formatting changes apply to all subgraphs. 
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

handles=guidata(src);

%find the bix axes that correspond to this subgraph:
activeindex=get(src,'userdata');

%if this big graph is not already selected, select it:
%note: dont use if statement here... always run raveselectgraph since it is also used to move graphs.
raveselectgraph(handles.allgraphs(activeindex),[]);

%reload handles (because tab has been reloaded/handles changed)
handles=guidata(src);
%udata=get(handles.fakeax(handles.activeindex),'userdata');


%unselect all sub graphs:
set(handles.subax{handles.activeindex},'xcolor',[0 0 0],'ycolor',[0 0 0]);
if iscell(get(handles.subax{handles.activeindex}(:),'xlabel'))
set(cell2mat(get(handles.subax{handles.activeindex}(:),'xlabel')),'color',[0 0 0]);
set(cell2mat(get(handles.subax{handles.activeindex}(:),'ylabel')),'color',[0 0 0]);
else
set(get(handles.subax{handles.activeindex}(:),'xlabel'),'color',[0 0 0]);
set(get(handles.subax{handles.activeindex}(:),'ylabel'),'color',[0 0 0]);
end


%select this subgraph: (if on format tab)
if strcmp(handles.activetab,'format')
set(src,'xcolor',[1 .5 0],'ycolor',[1 .5 0]);
set([get(src,'xlabel') get(src,'ylabel')],'color',[0 0 0]);
handles.activesubgraph=src;
else
    return
end

%[r,c]=find(handles.subax{handles.activeindex}==src);

%update handles:
guidata(src,handles)

%update current tab:
%note, this line must be last or else reload handles after this line.
% if strcmp(handles.activetab,'format')
%     eval([handles.activetab,'tab(src,[])'])
% end

if strcmp(handles.activetab,'format')
    xlim=get(handles.activesubgraph,'xlim'); %for scatterplot matrix, can select individual subplots and change their properities from here.
    ylim=get(handles.activesubgraph,'ylim');
    
    xminbox=findobj(handles.tabobjects,'tag','xminbox');
    xmaxbox=findobj(handles.tabobjects,'tag','xmaxbox');
    xlabelbox=findobj(handles.tabobjects,'tag','xlabelbox');
    yminbox=findobj(handles.tabobjects,'tag','yminbox');
    ymaxbox=findobj(handles.tabobjects,'tag','ymaxbox');
    ylabelbox=findobj(handles.tabobjects,'tag','xlabelbox');
    
    set(xminbox,'string',xlim(1))
    set(xmaxbox,'string',xlim(2))
    set(yminbox,'string',ylim(1))
    set(ymaxbox,'string',ylim(2))
    set(xlabelbox,'string',get(get(handles.activesubgraph,'xlabel'),'string'));
    set(ylabelbox,'string',get(get(handles.activesubgraph,'ylabel'),'string'));
    
end






