function varargout = ravetxt2mgui(varargin)
% RAVETXT2MGUI Convert a TXT or JMP function into a MATLAB function m-file.
%      This GUI is for use with RAVE only. for a similar non-rave gui, see
%      RSECONVERT.
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


% Last Modified by GUIDE v2.5 10-Mar-2010 15:01:01

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @ravetxt2mgui_OpeningFcn, ...
    'gui_OutputFcn',  @ravetxt2mgui_OutputFcn, ...
    'gui_LayoutFcn',  @ravetxt2mgui_LayoutFcn , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


function h=ravetxt2mgui_LayoutFcn(varargin)
h=openfig('ravetxt2mgui.fig');

% --- Executes just before ravetxt2mgui is made visible.
function ravetxt2mgui_OpeningFcn(hObject, eventdata, handles, varargin)
fighandle=varargin{1};
Handles=guidata(fighandle);
Handles.popup=handles;
handles=Handles;

src=varargin{1};
fig=ancestor(src,'figure');
thispos=get(hObject,'position');
screensize=get(fig,'position');
set(hObject,'units','pixels','position',[screensize(1)+screensize(3)/2-thispos(3)/2 screensize(2)+screensize(4)/2-thispos(4)/2 thispos(3) thispos(4)])

%set theme:
load raveprefs
set(0,'userdata','cancel');

set(hObject,'color',raveprefs.colors.frame);
set(handles.popup.uipanel1,'backgroundcolor',raveprefs.colors.tabbg);
set(handles.popup.uipanel2,'backgroundcolor',raveprefs.colors.tabbg);

set(handles.popup.titleaxes,'color','none','xcolor',raveprefs.colors.frame,...
    'ycolor',raveprefs.colors.frame,'zcolor',raveprefs.colors.frame);
set([handles.popup.titleaxes handles.popup.topframeaxes handles.popup.bottomframeaxes],'visible','off');

set(hObject,'units','pixels');

% %make title:
text(0,.4,'Import Function','parent',handles.popup.titleaxes,'fontname',handles.prefs.fonts.title,'fontsize',20*handles.prefs.fonts.titlescale,...
    'color',raveprefs.colors.title,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Paste/Type txt Function Here:','parent',handles.popup.topframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
    'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Configure','parent',handles.popup.bottomframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
    'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');

%get exising handles structure from maingui
%handles.indata=guidata(gcbo); %gcbo = "manage data sets" button in maingui

set(handles.popup.analysismenu,'string','Default');
set(handles.popup.datasetmenu,'string',handles.datasetnames)

% Choose default command line output for ravetxt2mgui
handles.popup.output = hObject;

% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = ravetxt2mgui_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.popup.output;


%%  --- Executes on button press in importbutton.
function importbutton_Callback(hObject, eventdata, handles)

%check that all fields are filled:
if isempty(get(handles.popup.txtbox,'string'))
    errordlg('You need to paste or type a function in the box.')
    return
end

if isempty(get(handles.popup.varnamebox,'string'))
    errordlg('You need to enter a name for the variable you are regressing.')
    return
end

ravetxt2m(handles.fig,[],get(handles.popup.varnamebox,'string'),get(handles.popup.txtbox,'string'),get(handles.popup.datasetmenu,'value'))

%clear input fieldS:
set(handles.popup.varnamebox,'string','');
set(handles.popup.txtbox,'string','');

%% update the data
guidata(hObject,handles);

% --- Executes on button press in donebutton.
function donebutton_Callback(hObject, eventdata, handles)
%set(0,'userdata',handles.indata);
close(gcf);


%% unused callbacks:
% --- Executes on selection change in analysismenu.
function analysismenu_Callback(hObject, eventdata, handles)
function analysismenu_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function datasetmenu_Callback(hObject, eventdata, handles)
function datasetmenu_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function sourcename_Callback(hObject, eventdata, handles)
function sourcename_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
