function constraintab(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

ravechangetab(src,[]);

handles=guidata(src);

%move front tabs to front if necessary
if handles.fronttabsfront==1 %move swap fronttabs and backtabs
    backpos=get(handles.backtabaxes,'position');
    frontpos=get(handles.fronttabaxes,'position');
    set(handles.fronttabaxes,'position',backpos)
    set(handles.backtabaxes,'position',frontpos)
    [x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,1,0); %#ok<NASGU>
    set(handles.fronttablines,'xdata',x,'ydata',y)
    set(handles.fronttabaxes,'xcolor',handles.colors.frame,'ycolor',handles.colors.frame);
    set(handles.backtabaxes,'xcolor',handles.colors.tabbg,'ycolor',handles.colors.tabbg);
end
handles.fronttabsfront=0;



set(handles.infobar,'string','');

delete(handles.tabobjects)

%raise this tab to top
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,2,1); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');

udata=get(handles.fakeax(handles.activeindex),'userdata');
if ~isempty(udata)
    d=udata.view.dataset;
    a=udata.view.analysis;
else
    d=1;
    a=1;
end

%% text headers
constrainttext=text(.15-.10317,.56*1.0317-.0317,'New Constraint','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
optimizetext=text(.15-.10317,.95*1.0317-.0317,'Ap','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
optimizetext2=text(.30-.10317,.95*1.0317-.0317,'ply Constraint','horizontalalignment','left','backgroundcolor','none',...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);


%% text labels

if isempty(handles.constrainttext{d}{a})
    conststring='No constraints have been created yet.';
else
    conststring=handles.constrainttext{d}{a};
end

constraintslisttext=uicontrol('style','text','position',[origin(1)+25 origin(2)+562 200 22],'string','Select a constraint:',...
    'parent',handles.fig,'fontname','arial','foregroundcolor',[0 0 0],'fontsize',10,'backgroundcolor',handles.colors.tabbg,'fontweight','bold',...
    'horizontalalignment','left');

constraintslist=uicontrol('style','listbox','position',[origin(1)+25 origin(2)+466 230 100],'string',conststring,...
    'parent',handles.fig,'backgroundcolor',[1 1 1],'tag','constraintslist','max',100);

selectfeasiblebutton=uicontrol('style','pushbutton','position',[origin(1)+25 origin(2)+430 230 24],'string','Select Feasible Points',...
    'parent',handles.fig,'backgroundcolor',handles.colors.buttonbg,'tag','selectbutton','callback',@selectfeasiblebutton_callback);
selectinfeasiblebutton=uicontrol('style','pushbutton','position',[origin(1)+25 origin(2)+400 230 24],'string','Select Infeasible Points',...
    'parent',handles.fig,'backgroundcolor',handles.colors.buttonbg,'tag','selectbutton','callback',@selectinfeasiblebutton_callback);


drawconstraintbutton=uicontrol('style','pushbutton','position',[origin(1)+25 origin(2)+370 230 24],'string','Draw this Constraint on Graph',...
    'parent',handles.fig,'backgroundcolor',handles.colors.buttonbg,'tag','selectbutton','callback',@drawconstraintbutton_callback);

if isempty(udata);set(drawconstraintbutton,'enable','off');end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
splaintext=uicontrol('style','text','position',[origin(1)+15 origin(2)+282 240 50],'string','Enter constraints in the field below, or by using the constraint editor in the Manage Analyses window.',...
    'horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.fig,'fontsize',10,'fontname','arial','foregroundcolor',[0 0 0],'fontweight','normal');

varlisttext=text(.15-.10317,.45*1.0317-.0317,'Click to insert variable name:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

constraintvarlist=uicontrol('position',[origin(1)+45 origin(2)+230 205 30],...
    'style','popupmenu','string',handles.allnames{d},'callback',@constraintvarlist_callback,...
    'backgroundcolor',[1 1 1],'tag','constraintvarlist');
%NOTE: constraintvarlist should always list all variables, even hidden columns.

editconstraintsbutton=uicontrol('style','pushbutton','position',[origin(1)+35 origin(2)+05 200 24],'string','View/Edit Constraints',...
    'horizontalalignment','left','backgroundcolor',handles.colors.buttonbg,...
    'parent',handles.fig,'fontsize',10,'fontname','arial','foregroundcolor',[0 0 0],'fontweight','normal');

%make java constraint editor:
j=javax.swing.JTextPane;
h=javax.swing.JScrollPane(j,javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
[crap,handy]=javacomponent(h,[origin(1)+15 origin(2)+110 235 120]); %#ok<NASGU>

ltbutton=uicontrol('style','togglebutton','position',[origin(1)+35 origin(2)+80 22 22],'cdata',imread('lt.bmp'),'tag','equality','userdata','<','callback',@equality_callback,'backgroundcolor',handles.colors.togglebuttonbg);
lebutton=uicontrol('style','togglebutton','position',[origin(1)+35+22 origin(2)+80 22 22],'cdata',imread('le.bmp'),'tag','equality','userdata','<=','callback',@equality_callback,'value',1,'backgroundcolor',handles.colors.togglebuttonbg);
eqbutton=uicontrol('style','togglebutton','position',[origin(1)+35+44 origin(2)+80 22 22],'cdata',imread('eq.bmp'),'tag','equality','userdata','=','callback',@equality_callback,'backgroundcolor',handles.colors.togglebuttonbg);
gebutton=uicontrol('style','togglebutton','position',[origin(1)+35+66 origin(2)+80 22 22],'cdata',imread('ge.bmp'),'tag','equality','userdata','>=','callback',@equality_callback,'backgroundcolor',handles.colors.togglebuttonbg);
gtbutton=uicontrol('style','togglebutton','position',[origin(1)+35+88 origin(2)+80 22 22],'cdata',imread('gt.bmp'),'tag','equality','userdata','>','callback',@equality_callback,'backgroundcolor',handles.colors.togglebuttonbg);

constraintvalueedit=uicontrol('style','edit','position',[origin(1)+160 origin(2)+79 90 24],'string','0',...
    'horizontalalignment','left','backgroundcolor',[1 1 1],...
    'parent',handles.fig,'fontsize',10,'fontname','arial','foregroundcolor',[0 0 0],'fontweight','normal','tag','constraintvalue');

applyconstraintbutton=uicontrol('style','pushbutton','position',[origin(1)+35 origin(2)+45 200 24],'string','Create this Constraint',...
    'horizontalalignment','left','backgroundcolor',handles.colors.buttonbg,...
    'parent',handles.fig,'fontsize',14,'fontname','arial','foregroundcolor',[0 0 0],'fontweight','normal','callback',@applyconstraint_callback);

handles.tabobjects=[constrainttext optimizetext splaintext editconstraintsbutton constraintvarlist ltbutton lebutton...
    eqbutton gebutton gtbutton constraintvalueedit applyconstraintbutton varlisttext optimizetext2 constraintslist constraintslisttext...
    selectfeasiblebutton selectinfeasiblebutton drawconstraintbutton handy];

handles.javacomps=crap;
handles.temp.constraintfield=j;

guidata(src,handles);




function constraintvarlist_callback(src,ev) %#ok<INUSD>
handles=guidata(src);


udata=get(handles.fakeax(handles.activeindex),'userdata');
if ~isempty(udata)
    d=udata.view.dataset;
else
    d=handles.maintable.d;
end


thisvariable=handles.allnames{d}{get(src,'value')};
jtext=handles.temp.constraintfield;
caretpos=jtext.getCaretPosition;
currentstring=jtext.getText;
currentstring=char(currentstring);
newstring=[currentstring(1:caretpos),' ',thisvariable,' ',currentstring(caretpos+1:end)];
jtext.setText(newstring)
jtext.requestFocus

newcaretpos=caretpos+2+length(thisvariable);
jtext.setCaretPosition(newcaretpos);


function equality_callback(src,ev) %#ok<INUSD>
handles=guidata(src);

equalities=findobj(handles.tabobjects,'tag','equality');
set(equalities,'value',0)
set(src,'value',1)

constraintvalueedit=findobj(handles.tabobjects,'tag','constraintvalue');
uicontrol(constraintvalueedit);

set(handles.infobar,'string','Note: RAVE currently treats < as <= and > as >=')




function applyconstraint_callback(src,ev) %#ok<INUSD>
%turn constraint string into matlab function. similar to ravejmp2m but without the jmp syntax.

handles=guidata(src);

udata=get(handles.fakeax(handles.activeindex),'userdata');
if ~isempty(udata)
    d=udata.view.dataset;
    a=udata.view.analysis;
else
    d=1;
    a=1;
end


thisequality=findobj(handles.tabobjects,'tag','equality','value',1);
thisequality=get(thisequality,'userdata');

constraintfield=findobj(handles.tabobjects,'tag','constraintvalue');
try
    constraintvalue=str2double(get(constraintfield,'string'));
catch %#ok<CTCH>
    errordlg('The small text box next to the inequality buttons must contain a numerical value representing the right hand side of the constraint equation.',...
        'Value must be numeric')
    return
end

jtext=handles.temp.constraintfield;
constraintstring=jtext.getText;
constraintstring=char(constraintstring);

if isempty(constraintstring) || isempty(constraintvalue)
    return
end

[constraintfunctionstring,constrainttype,constraintvars]=raveprocessconstraint(handles,udata.view.dataset,constraintstring,thisequality,constraintvalue);

%store this function annonymously in handles.

try
    eval(['newhandle=@(data) ',constraintfunctionstring,';']);
catch %#ok<CTCH>
    errordlg('Something went wrong while creating a constraint. Check to see if you spelled everything right and used correct MATLAB syntax.')
end

handles.constrainthandles{d}{a}{end+1}=newhandle;
handles.constrainttext{d}{a}{end+1}=strtrim([constraintstring,thisequality,' ',num2str(constraintvalue)]);
handles.constrainttype{dt}{a}{end+1}=constrainttype;
handles.constraintvars{d}{a}{end+1}=constraintvars;
handles.constraintcolors{d}{a}{end+1}=handles.colors.constraint;
handles.constraintscalers{d}{a}(end+1)=1;

jtext.setText('');
set(constraintfield,'string','0');

%update the list:
constraintslist=findobj(handles.tabobjects,'tag','constraintslist');
set(constraintslist,'string',handles.constrainttext{d}{a});

%evaluate this constraint on current data set, and store results in handles.constraintvalues:

thishandle=handles.constrainthandles{d}{a}{end};

thisindex=numel(handles.constrainthandles{d}{a});

guidata(src,handles);

%evaluate constraint
handles.constraintvalues{d}{a}{end+1}=raveevaluateconstraint(src,thisindex,handles.alldata{d},0);
%=thishandle(handles.alldata{udata.view.dataset});

%evaluate constraint at end points to get normalization parameters:
mins=handles.minlimit{d}{a};
maxs=handles.maxlimit{d}{a};

minvalue=raveevaluateconstraint(src,thisindex,mins,0);
maxvalue=raveevaluateconstraint(src,thisindex,maxs,0);
meanvalue=raveevaluateconstraint(src,thisindex,(mins+maxs)./2,0);

sample=[minvalue maxvalue meanvalue];

sample(isnan(sample))=1; %not really sure what to do if nan pops up (most likely from 0/0 expression)

offset=mean(sample);
range=max(sample)-min(sample);

if range==0
    range=1;
end



%handles.constraintadders{udata.view.dataset}{udata.view.analysis}{end+1}=offset;
handles.constraintscalers{d}{a}(end+1)=range;

guidata(handles.fig,handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function selectinfeasiblebutton_callback(src,ev) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
if ~isempty(udata)
    d=udata.view.dataset;
    a=udata.view.analysis;
else
    d=1;
    a=1;
end

constraintslist=findobj(handles.tabobjects,'tag','constraintslist');
thisconstraint=get(constraintslist,'value');

%evaluate this function on the current data set:

allvalues=cell2mat(handles.constraintvalues{d}{a}(thisconstraint));
inpoints=any(allvalues>=0,2); %infeasible points

handles.isselected{d}{a}=inpoints;
guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected',true);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function selectfeasiblebutton_callback(src,ev) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
if ~isempty(udata)
    d=udata.view.dataset;
    a=udata.view.analysis;
else
    d=1;
    a=1;
end

constraintslist=findobj(handles.tabobjects,'tag','constraintslist');
thisconstraint=get(constraintslist,'value');

%evaluate this function on the current data set:

allvalues=cell2mat(handles.constraintvalues{d}{a}(thisconstraint));
inpoints=all(allvalues<=0,2); %infeasible points

handles.isselected{d}{a}=inpoints;
guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected',true);



function drawconstraintbutton_callback(src,ev) 
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

constraintslist=findobj(handles.tabobjects,'tag','constraintslist');
selectedconstraints=get(constraintslist,'value');
ai=handles.activeindex;

udata.view.constraints=selectedconstraints;
set(handles.fakeax(handles.activeindex),'userdata',udata);



h=ravedrawconstraint(src,ai,selectedconstraints);

